#include <mooutils/mooglade.h>
#include <mooutils/mooi18n.h>
#include <gtk/gtk.h>

static const char _about_dialog_xml_glade_xml[] =
"<?xml version=\"1.0\"?>"
"<glade-interface>"
"  <widget class=\"GtkDialog\" id=\"AboutDialog\">"
"    <property name=\"title\" translatable=\"yes\" context=\"yes\" comments=\"Translators: do not translate the part before |\">Dialog title|About</property>"
"    <property name=\"resizable\">False</property>"
"    <property name=\"window_position\">GTK_WIN_POS_CENTER_ON_PARENT</property>"
"    <property name=\"destroy_with_parent\">True</property>"
"    <property name=\"type_hint\">GDK_WINDOW_TYPE_HINT_DIALOG</property>"
"    <property name=\"has_separator\">False</property>"
"    <child internal-child=\"vbox\">"
"      <widget class=\"GtkVBox\" id=\"dialog-vbox4\">"
"        <property name=\"visible\">True</property>"
"        <child>"
"          <widget class=\"GtkVBox\" id=\"vbox1\">"
"            <property name=\"visible\">True</property>"
"            <property name=\"border_width\">12</property>"
"            <property name=\"spacing\">8</property>"
"            <child>"
"              <widget class=\"GtkImage\" id=\"logo\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"stock\">gtk-about</property>"
"                <property name=\"icon_size\">6</property>"
"              </widget>"
"              <packing>"
"                <property name=\"expand\">False</property>"
"                <property name=\"fill\">False</property>"
"              </packing>"
"            </child>"
"            <child>"
"              <widget class=\"GtkLabel\" id=\"name\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"label\" context=\"yes\">&lt;span size=\"xx-large\"&gt;&lt;b&gt;The App&lt;/b&gt;&lt;/span&gt;</property>"
"                <property name=\"use_markup\">True</property>"
"                <property name=\"selectable\">True</property>"
"              </widget>"
"              <packing>"
"                <property name=\"expand\">False</property>"
"                <property name=\"fill\">False</property>"
"                <property name=\"position\">1</property>"
"              </packing>"
"            </child>"
"            <child>"
"              <widget class=\"GtkLabel\" id=\"description\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"label\" context=\"yes\">The App is an app</property>"
"                <property name=\"selectable\">True</property>"
"              </widget>"
"              <packing>"
"                <property name=\"expand\">False</property>"
"                <property name=\"fill\">False</property>"
"                <property name=\"position\">2</property>"
"              </packing>"
"            </child>"
"            <child>"
"              <widget class=\"GtkLabel\" id=\"copyright\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"label\" context=\"yes\">&lt;small&gt;&#xA9; 2004-2006 The Author&lt;/small&gt;</property>"
"                <property name=\"use_markup\">True</property>"
"                <property name=\"selectable\">True</property>"
"              </widget>"
"              <packing>"
"                <property name=\"expand\">False</property>"
"                <property name=\"fill\">False</property>"
"                <property name=\"position\">3</property>"
"              </packing>"
"            </child>"
"            <child>"
"              <widget class=\"GtkAlignment\" id=\"alignment2\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"xscale\">0</property>"
"                <child>"
"                  <widget class=\"GtkLabel\" id=\"url:MooLinkLabel\">"
"                    <property name=\"visible\">True</property>"
"                    <property name=\"label\" context=\"yes\">&lt;span foreground=\"#0000FF\"&gt;http://somesite.org&lt;/span&gt;</property>"
"                    <property name=\"use_markup\">True</property>"
"                  </widget>"
"                </child>"
"              </widget>"
"              <packing>"
"                <property name=\"expand\">False</property>"
"                <property name=\"fill\">False</property>"
"                <property name=\"position\">4</property>"
"              </packing>"
"            </child>"
"          </widget>"
"          <packing>"
"            <property name=\"position\">1</property>"
"          </packing>"
"        </child>"
"        <child internal-child=\"action_area\">"
"          <widget class=\"GtkHButtonBox\" id=\"dialog-action_area4\">"
"            <property name=\"visible\">True</property>"
"            <property name=\"layout_style\">GTK_BUTTONBOX_END</property>"
"            <child>"
"              <widget class=\"GtkButton\" id=\"credits_button\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"can_focus\">True</property>"
"                <property name=\"can_default\">True</property>"
"                <property name=\"focus_on_click\">False</property>"
"                <property name=\"response_id\">0</property>"
"                <child>"
"                  <widget class=\"GtkAlignment\" id=\"alignment3\">"
"                    <property name=\"visible\">True</property>"
"                    <property name=\"xscale\">0</property>"
"                    <property name=\"yscale\">0</property>"
"                    <child>"
"                      <widget class=\"GtkHBox\" id=\"hbox2\">"
"                        <property name=\"visible\">True</property>"
"                        <property name=\"spacing\">2</property>"
"                        <child>"
"                          <widget class=\"GtkImage\" id=\"image3\">"
"                            <property name=\"visible\">True</property>"
"                            <property name=\"stock\">gtk-about</property>"
"                          </widget>"
"                          <packing>"
"                            <property name=\"expand\">False</property>"
"                            <property name=\"fill\">False</property>"
"                          </packing>"
"                        </child>"
"                        <child>"
"                          <widget class=\"GtkLabel\" id=\"label7\">"
"                            <property name=\"visible\">True</property>"
"                            <property name=\"label\" translatable=\"yes\" context=\"yes\" comments=\"Credits button label in About dialog\">C_redits</property>"
"                            <property name=\"use_underline\">True</property>"
"                          </widget>"
"                          <packing>"
"                            <property name=\"expand\">False</property>"
"                            <property name=\"fill\">False</property>"
"                            <property name=\"position\">1</property>"
"                          </packing>"
"                        </child>"
"                      </widget>"
"                    </child>"
"                  </widget>"
"                </child>"
"              </widget>"
"            </child>"
"            <child>"
"              <widget class=\"GtkButton\" id=\"license_button\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"can_focus\">True</property>"
"                <property name=\"can_default\">True</property>"
"                <property name=\"label\" translatable=\"yes\" context=\"yes\" comments=\"License button label in About dialog\">_License</property>"
"                <property name=\"use_underline\">True</property>"
"                <property name=\"focus_on_click\">False</property>"
"                <property name=\"response_id\">0</property>"
"              </widget>"
"              <packing>"
"                <property name=\"position\">1</property>"
"              </packing>"
"            </child>"
"            <child>"
"              <widget class=\"GtkButton\" id=\"close_button\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"can_focus\">True</property>"
"                <property name=\"can_default\">True</property>"
"                <property name=\"label\" context=\"yes\">gtk-close</property>"
"                <property name=\"use_stock\">True</property>"
"                <property name=\"focus_on_click\">False</property>"
"                <property name=\"response_id\">0</property>"
"              </widget>"
"              <packing>"
"                <property name=\"position\">2</property>"
"              </packing>"
"            </child>"
"          </widget>"
"          <packing>"
"            <property name=\"expand\">False</property>"
"            <property name=\"fill\">False</property>"
"            <property name=\"pack_type\">GTK_PACK_END</property>"
"          </packing>"
"        </child>"
"      </widget>"
"    </child>"
"  </widget>"
"</glade-interface>"

;

typedef struct AboutDialogXml AboutDialogXml;

struct AboutDialogXml {
    MooGladeXML *xml;

    GtkDialog *AboutDialog;
    GtkImage *logo;
    GtkLabel *name;
    GtkLabel *description;
    GtkLabel *copyright;
    MooLinkLabel *url;
    GtkButton *credits_button;
    GtkButton *license_button;
    GtkButton *close_button;

};

static void
_about_dialog_xml_free (AboutDialogXml *xml)
{
    if (xml)
    {
        if (xml->xml)
            g_object_unref (xml->xml);
        g_free (xml);
    }
}

G_GNUC_UNUSED static AboutDialogXml *
about_dialog_xml_get (gpointer widget)
{
    return (AboutDialogXml*) g_object_get_data (G_OBJECT (widget), "moo-generated-glade-xml");
}

static gboolean
_about_dialog_xml_finish_build (AboutDialogXml *xml)
{
    g_return_val_if_fail(xml != NULL, FALSE);

    xml->AboutDialog = (GtkDialog*) moo_glade_xml_get_widget (xml->xml, "AboutDialog");
    g_return_val_if_fail (xml->AboutDialog != NULL, FALSE);
    xml->logo = (GtkImage*) moo_glade_xml_get_widget (xml->xml, "logo");
    g_return_val_if_fail (xml->logo != NULL, FALSE);
    xml->name = (GtkLabel*) moo_glade_xml_get_widget (xml->xml, "name");
    g_return_val_if_fail (xml->name != NULL, FALSE);
    xml->description = (GtkLabel*) moo_glade_xml_get_widget (xml->xml, "description");
    g_return_val_if_fail (xml->description != NULL, FALSE);
    xml->copyright = (GtkLabel*) moo_glade_xml_get_widget (xml->xml, "copyright");
    g_return_val_if_fail (xml->copyright != NULL, FALSE);
    xml->url = (MooLinkLabel*) moo_glade_xml_get_widget (xml->xml, "url:MooLinkLabel");
    g_return_val_if_fail (xml->url != NULL, FALSE);
    xml->credits_button = (GtkButton*) moo_glade_xml_get_widget (xml->xml, "credits_button");
    g_return_val_if_fail (xml->credits_button != NULL, FALSE);
    xml->license_button = (GtkButton*) moo_glade_xml_get_widget (xml->xml, "license_button");
    g_return_val_if_fail (xml->license_button != NULL, FALSE);
    xml->close_button = (GtkButton*) moo_glade_xml_get_widget (xml->xml, "close_button");
    g_return_val_if_fail (xml->close_button != NULL, FALSE);

    g_object_set_data_full (G_OBJECT (xml->AboutDialog), "moo-generated-glade-xml",
                            xml, (GDestroyNotify) _about_dialog_xml_free);
    return TRUE;
}

static gboolean
about_dialog_xml_build (AboutDialogXml *xml)
{
    GError *error = NULL;
    if (!moo_glade_xml_parse_memory (xml->xml, _about_dialog_xml_glade_xml, -1, "AboutDialog", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _about_dialog_xml_finish_build (xml);
}

static gboolean
about_dialog_xml_fill (AboutDialogXml *xml, GtkWidget *root)
{
    GError *error = NULL;
    if (!moo_glade_xml_fill_widget (xml->xml, root, _about_dialog_xml_glade_xml, -1, "AboutDialog", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _about_dialog_xml_finish_build (xml);
}

static AboutDialogXml *
about_dialog_xml_new_empty (void)
{
    AboutDialogXml *xml = g_new0 (AboutDialogXml, 1);
    xml->xml = moo_glade_xml_new_empty (GETTEXT_PACKAGE);

    return xml;
}

G_GNUC_UNUSED static AboutDialogXml *
about_dialog_xml_new (void)
{
    AboutDialogXml *xml = about_dialog_xml_new_empty ();
    if (!about_dialog_xml_build (xml))
    {
        _about_dialog_xml_free (xml);
        xml = NULL;
    }
    return xml;
}

G_GNUC_UNUSED static AboutDialogXml *
about_dialog_xml_new_with_root (GtkWidget *root)
{
    AboutDialogXml *xml = about_dialog_xml_new_empty ();
    if (!about_dialog_xml_fill (xml, root))
    {
        _about_dialog_xml_free (xml);
        xml = NULL;
    }
    return xml;
}
