#include <mooutils/mooglade.h>
#include <mooutils/mooi18n.h>
#include <gtk/gtk.h>

static const char _license_dialog_xml_glade_xml[] =
"<?xml version=\"1.0\"?>"
"<glade-interface>"
"  <widget class=\"GtkDialog\" id=\"LicenseDialog\">"
"    <property name=\"title\" translatable=\"yes\" context=\"yes\" comments=\"Translators: do not translate the part before |\">Dialog title|License</property>"
"    <property name=\"window_position\">GTK_WIN_POS_CENTER_ON_PARENT</property>"
"    <property name=\"default_width\">420</property>"
"    <property name=\"default_height\">320</property>"
"    <property name=\"destroy_with_parent\">True</property>"
"    <property name=\"type_hint\">GDK_WINDOW_TYPE_HINT_DIALOG</property>"
"    <property name=\"has_separator\">False</property>"
"    <child internal-child=\"vbox\">"
"      <widget class=\"GtkVBox\" id=\"dialog-vbox2\">"
"        <property name=\"visible\">True</property>"
"        <child>"
"          <widget class=\"GtkScrolledWindow\" id=\"scrolledwindow2\">"
"            <property name=\"visible\">True</property>"
"            <property name=\"can_focus\">False</property>"
"            <property name=\"hscrollbar_policy\">GTK_POLICY_AUTOMATIC</property>"
"            <property name=\"vscrollbar_policy\">GTK_POLICY_AUTOMATIC</property>"
"            <property name=\"shadow_type\">GTK_SHADOW_IN</property>"
"            <child>"
"              <widget class=\"GtkTextView\" id=\"textview\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"editable\">False</property>"
"                <property name=\"cursor_visible\">False</property>"
"              </widget>"
"            </child>"
"          </widget>"
"          <packing>"
"            <property name=\"position\">1</property>"
"          </packing>"
"        </child>"
"        <child internal-child=\"action_area\">"
"          <widget class=\"GtkHButtonBox\" id=\"dialog-action_area2\">"
"            <property name=\"visible\">True</property>"
"            <property name=\"layout_style\">GTK_BUTTONBOX_END</property>"
"            <child>"
"              <widget class=\"GtkButton\" id=\"close1\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"has_focus\">True</property>"
"                <property name=\"can_default\">True</property>"
"                <property name=\"has_default\">True</property>"
"                <property name=\"label\">gtk-close</property>"
"                <property name=\"use_stock\">True</property>"
"                <property name=\"response_id\">-6</property>"
"              </widget>"
"            </child>"
"          </widget>"
"          <packing>"
"            <property name=\"expand\">False</property>"
"            <property name=\"pack_type\">GTK_PACK_END</property>"
"          </packing>"
"        </child>"
"      </widget>"
"    </child>"
"  </widget>"
"</glade-interface>"

;

typedef struct LicenseDialogXml LicenseDialogXml;

struct LicenseDialogXml {
    MooGladeXML *xml;

    GtkDialog *LicenseDialog;
    GtkTextView *textview;

};

static void
_license_dialog_xml_free (LicenseDialogXml *xml)
{
    if (xml)
    {
        if (xml->xml)
            g_object_unref (xml->xml);
        g_free (xml);
    }
}

G_GNUC_UNUSED static LicenseDialogXml *
license_dialog_xml_get (gpointer widget)
{
    return (LicenseDialogXml*) g_object_get_data (G_OBJECT (widget), "moo-generated-glade-xml");
}

static gboolean
_license_dialog_xml_finish_build (LicenseDialogXml *xml)
{
    g_return_val_if_fail(xml != NULL, FALSE);

    xml->LicenseDialog = (GtkDialog*) moo_glade_xml_get_widget (xml->xml, "LicenseDialog");
    g_return_val_if_fail (xml->LicenseDialog != NULL, FALSE);
    xml->textview = (GtkTextView*) moo_glade_xml_get_widget (xml->xml, "textview");
    g_return_val_if_fail (xml->textview != NULL, FALSE);

    g_object_set_data_full (G_OBJECT (xml->LicenseDialog), "moo-generated-glade-xml",
                            xml, (GDestroyNotify) _license_dialog_xml_free);
    return TRUE;
}

static gboolean
license_dialog_xml_build (LicenseDialogXml *xml)
{
    GError *error = NULL;
    if (!moo_glade_xml_parse_memory (xml->xml, _license_dialog_xml_glade_xml, -1, "LicenseDialog", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _license_dialog_xml_finish_build (xml);
}

static gboolean
license_dialog_xml_fill (LicenseDialogXml *xml, GtkWidget *root)
{
    GError *error = NULL;
    if (!moo_glade_xml_fill_widget (xml->xml, root, _license_dialog_xml_glade_xml, -1, "LicenseDialog", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _license_dialog_xml_finish_build (xml);
}

static LicenseDialogXml *
license_dialog_xml_new_empty (void)
{
    LicenseDialogXml *xml = g_new0 (LicenseDialogXml, 1);
    xml->xml = moo_glade_xml_new_empty (GETTEXT_PACKAGE);

    return xml;
}

G_GNUC_UNUSED static LicenseDialogXml *
license_dialog_xml_new (void)
{
    LicenseDialogXml *xml = license_dialog_xml_new_empty ();
    if (!license_dialog_xml_build (xml))
    {
        _license_dialog_xml_free (xml);
        xml = NULL;
    }
    return xml;
}

G_GNUC_UNUSED static LicenseDialogXml *
license_dialog_xml_new_with_root (GtkWidget *root)
{
    LicenseDialogXml *xml = license_dialog_xml_new_empty ();
    if (!license_dialog_xml_fill (xml, root))
    {
        _license_dialog_xml_free (xml);
        xml = NULL;
    }
    return xml;
}
