#include <mooutils/mooglade.h>
#include <mooutils/mooi18n.h>
#include <gtk/gtk.h>

static const char _prefs_view_xml_glade_xml[] =
"<?xml version=\"1.0\"?>"
"<glade-interface>"
"  <!-- interface-requires gtk+ 2.8 -->"
"  <!-- interface-naming-policy toplevel-contextual -->"
"  <widget class=\"GtkWindow\" id=\"window2\">"
"    <child>"
"      <widget class=\"GtkVBox\" id=\"PrefsView\">"
"        <property name=\"visible\">True</property>"
"        <property name=\"border_width\">12</property>"
"        <property name=\"spacing\">18</property>"
"        <child>"
"          <widget class=\"GtkVBox\" id=\"vbox9\">"
"            <property name=\"visible\">True</property>"
"            <property name=\"spacing\">6</property>"
"            <child>"
"              <widget class=\"GtkLabel\" id=\"label3\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"xalign\">0</property>"
"                <property name=\"label\" translatable=\"yes\">&lt;b&gt;Text wrapping&lt;/b&gt;</property>"
"                <property name=\"use_markup\">True</property>"
"              </widget>"
"              <packing>"
"                <property name=\"expand\">False</property>"
"                <property name=\"fill\">False</property>"
"                <property name=\"position\">0</property>"
"              </packing>"
"            </child>"
"            <child>"
"              <widget class=\"GtkAlignment\" id=\"alignment2\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"left_padding\">12</property>"
"                <child>"
"                  <widget class=\"GtkVBox\" id=\"vbox10\">"
"                    <property name=\"visible\">True</property>"
"                    <property name=\"spacing\">6</property>"
"                    <child>"
"                      <widget class=\"GtkCheckButton\" id=\"enable_wrapping\">"
"                        <property name=\"label\" translatable=\"yes\">Enable text wrapping</property>"
"                        <property name=\"visible\">True</property>"
"                        <property name=\"can_focus\">False</property>"
"                        <property name=\"receives_default\">False</property>"
"                        <property name=\"use_underline\">True</property>"
"                        <property name=\"draw_indicator\">True</property>"
"                      </widget>"
"                      <packing>"
"                        <property name=\"expand\">False</property>"
"                        <property name=\"fill\">False</property>"
"                        <property name=\"position\">0</property>"
"                      </packing>"
"                    </child>"
"                    <child>"
"                      <widget class=\"GtkCheckButton\" id=\"dont_split_words\">"
"                        <property name=\"label\" translatable=\"yes\">Do not split words</property>"
"                        <property name=\"visible\">True</property>"
"                        <property name=\"can_focus\">False</property>"
"                        <property name=\"receives_default\">False</property>"
"                        <property name=\"use_underline\">True</property>"
"                        <property name=\"draw_indicator\">True</property>"
"                      </widget>"
"                      <packing>"
"                        <property name=\"expand\">False</property>"
"                        <property name=\"fill\">False</property>"
"                        <property name=\"position\">1</property>"
"                      </packing>"
"                    </child>"
"                  </widget>"
"                </child>"
"              </widget>"
"              <packing>"
"                <property name=\"expand\">False</property>"
"                <property name=\"fill\">False</property>"
"                <property name=\"position\">1</property>"
"              </packing>"
"            </child>"
"          </widget>"
"          <packing>"
"            <property name=\"expand\">False</property>"
"            <property name=\"fill\">False</property>"
"            <property name=\"position\">0</property>"
"          </packing>"
"        </child>"
"        <child>"
"          <widget class=\"GtkVBox\" id=\"vbox11\">"
"            <property name=\"visible\">True</property>"
"            <property name=\"spacing\">6</property>"
"            <child>"
"              <widget class=\"GtkLabel\" id=\"label7\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"xalign\">0</property>"
"                <property name=\"label\" translatable=\"yes\">&lt;b&gt;Highlighting&lt;/b&gt;</property>"
"                <property name=\"use_markup\">True</property>"
"              </widget>"
"              <packing>"
"                <property name=\"expand\">False</property>"
"                <property name=\"fill\">False</property>"
"                <property name=\"position\">0</property>"
"              </packing>"
"            </child>"
"            <child>"
"              <widget class=\"GtkAlignment\" id=\"alignment6\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"left_padding\">12</property>"
"                <child>"
"                  <widget class=\"GtkVBox\" id=\"vbox12\">"
"                    <property name=\"visible\">True</property>"
"                    <property name=\"spacing\">6</property>"
"                    <child>"
"                      <widget class=\"GtkCheckButton\" id=\"check_enable_highlighting\">"
"                        <property name=\"label\" translatable=\"yes\">Enable syntax highlighting</property>"
"                        <property name=\"visible\">True</property>"
"                        <property name=\"can_focus\">False</property>"
"                        <property name=\"receives_default\">False</property>"
"                        <property name=\"use_underline\">True</property>"
"                        <property name=\"draw_indicator\">True</property>"
"                      </widget>"
"                      <packing>"
"                        <property name=\"expand\">False</property>"
"                        <property name=\"fill\">False</property>"
"                        <property name=\"position\">0</property>"
"                      </packing>"
"                    </child>"
"                    <child>"
"                      <widget class=\"GtkCheckButton\" id=\"check_highlight_matching_brackets\">"
"                        <property name=\"label\" translatable=\"yes\">Highlight matching brackets</property>"
"                        <property name=\"visible\">True</property>"
"                        <property name=\"can_focus\">False</property>"
"                        <property name=\"receives_default\">False</property>"
"                        <property name=\"use_underline\">True</property>"
"                        <property name=\"draw_indicator\">True</property>"
"                      </widget>"
"                      <packing>"
"                        <property name=\"expand\">False</property>"
"                        <property name=\"fill\">False</property>"
"                        <property name=\"position\">1</property>"
"                      </packing>"
"                    </child>"
"                    <child>"
"                      <widget class=\"GtkCheckButton\" id=\"check_highlight_mismatching_brackets\">"
"                        <property name=\"label\" translatable=\"yes\">Highlight mismatching brackets</property>"
"                        <property name=\"visible\">True</property>"
"                        <property name=\"can_focus\">False</property>"
"                        <property name=\"receives_default\">False</property>"
"                        <property name=\"use_underline\">True</property>"
"                        <property name=\"draw_indicator\">True</property>"
"                      </widget>"
"                      <packing>"
"                        <property name=\"expand\">False</property>"
"                        <property name=\"fill\">False</property>"
"                        <property name=\"position\">2</property>"
"                      </packing>"
"                    </child>"
"                    <child>"
"                      <widget class=\"GtkCheckButton\" id=\"check_highlight_current_line\">"
"                        <property name=\"label\" translatable=\"yes\">Highlight current line</property>"
"                        <property name=\"visible\">True</property>"
"                        <property name=\"can_focus\">False</property>"
"                        <property name=\"receives_default\">False</property>"
"                        <property name=\"use_underline\">True</property>"
"                        <property name=\"draw_indicator\">True</property>"
"                      </widget>"
"                      <packing>"
"                        <property name=\"expand\">False</property>"
"                        <property name=\"fill\">False</property>"
"                        <property name=\"position\">3</property>"
"                      </packing>"
"                    </child>"
"                  </widget>"
"                </child>"
"              </widget>"
"              <packing>"
"                <property name=\"expand\">False</property>"
"                <property name=\"fill\">False</property>"
"                <property name=\"position\">1</property>"
"              </packing>"
"            </child>"
"          </widget>"
"          <packing>"
"            <property name=\"expand\">False</property>"
"            <property name=\"fill\">False</property>"
"            <property name=\"position\">1</property>"
"          </packing>"
"        </child>"
"        <child>"
"          <widget class=\"GtkVBox\" id=\"vbox13\">"
"            <property name=\"visible\">True</property>"
"            <property name=\"spacing\">6</property>"
"            <child>"
"              <widget class=\"GtkLabel\" id=\"label8\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"xalign\">0</property>"
"                <property name=\"label\" translatable=\"yes\">&lt;b&gt;Misc&lt;/b&gt;</property>"
"                <property name=\"use_markup\">True</property>"
"              </widget>"
"              <packing>"
"                <property name=\"expand\">False</property>"
"                <property name=\"fill\">False</property>"
"                <property name=\"position\">0</property>"
"              </packing>"
"            </child>"
"            <child>"
"              <widget class=\"GtkAlignment\" id=\"alignment7\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"left_padding\">12</property>"
"                <child>"
"                  <widget class=\"GtkVBox\" id=\"vbox14\">"
"                    <property name=\"visible\">True</property>"
"                    <property name=\"spacing\">6</property>"
"                    <child>"
"                      <widget class=\"GtkCheckButton\" id=\"show_line_numbers\">"
"                        <property name=\"label\" translatable=\"yes\">Show line numbers</property>"
"                        <property name=\"visible\">True</property>"
"                        <property name=\"can_focus\">False</property>"
"                        <property name=\"receives_default\">False</property>"
"                        <property name=\"use_underline\">True</property>"
"                        <property name=\"draw_indicator\">True</property>"
"                      </widget>"
"                      <packing>"
"                        <property name=\"expand\">False</property>"
"                        <property name=\"fill\">False</property>"
"                        <property name=\"position\">0</property>"
"                      </packing>"
"                    </child>"
"                    <child>"
"                      <widget class=\"GtkCheckButton\" id=\"check_show_tabs\">"
"                        <property name=\"label\" translatable=\"yes\">Show tabs</property>"
"                        <property name=\"visible\">True</property>"
"                        <property name=\"can_focus\">False</property>"
"                        <property name=\"receives_default\">False</property>"
"                        <property name=\"use_underline\">True</property>"
"                        <property name=\"draw_indicator\">True</property>"
"                      </widget>"
"                      <packing>"
"                        <property name=\"expand\">False</property>"
"                        <property name=\"fill\">False</property>"
"                        <property name=\"position\">1</property>"
"                      </packing>"
"                    </child>"
"                    <child>"
"                      <widget class=\"GtkCheckButton\" id=\"check_show_spaces\">"
"                        <property name=\"label\" translatable=\"yes\">Show spaces</property>"
"                        <property name=\"visible\">True</property>"
"                        <property name=\"can_focus\">False</property>"
"                        <property name=\"receives_default\">False</property>"
"                        <property name=\"use_underline\">True</property>"
"                        <property name=\"draw_indicator\">True</property>"
"                      </widget>"
"                      <packing>"
"                        <property name=\"expand\">False</property>"
"                        <property name=\"fill\">False</property>"
"                        <property name=\"position\">2</property>"
"                      </packing>"
"                    </child>"
"                    <child>"
"                      <widget class=\"GtkCheckButton\" id=\"check_show_trailing_spaces\">"
"                        <property name=\"label\" translatable=\"yes\">Show trailing spaces</property>"
"                        <property name=\"visible\">True</property>"
"                        <property name=\"can_focus\">False</property>"
"                        <property name=\"receives_default\">False</property>"
"                        <property name=\"use_underline\">True</property>"
"                        <property name=\"draw_indicator\">True</property>"
"                      </widget>"
"                      <packing>"
"                        <property name=\"expand\">False</property>"
"                        <property name=\"fill\">False</property>"
"                        <property name=\"position\">3</property>"
"                      </packing>"
"                    </child>"
"                    <child>"
"                      <widget class=\"GtkHBox\" id=\"hbox3\">"
"                        <property name=\"visible\">True</property>"
"                        <child>"
"                          <widget class=\"GtkCheckButton\" id=\"draw_rigth_margin\">"
"                            <property name=\"label\" translatable=\"yes\" comments=\"Part of the phrase &quot;Draw right margin at column [XX]&quot;\">Draw right margin</property>"
"                            <property name=\"visible\">True</property>"
"                            <property name=\"can_focus\">False</property>"
"                            <property name=\"receives_default\">False</property>"
"                            <property name=\"draw_indicator\">True</property>"
"                          </widget>"
"                          <packing>"
"                            <property name=\"expand\">False</property>"
"                            <property name=\"fill\">False</property>"
"                            <property name=\"position\">0</property>"
"                          </packing>"
"                        </child>"
"                        <child>"
"                          <widget class=\"GtkHBox\" id=\"right_margin_box\">"
"                            <property name=\"visible\">True</property>"
"                            <property name=\"spacing\">6</property>"
"                            <child>"
"                              <widget class=\"GtkLabel\" id=\"label9\">"
"                                <property name=\"visible\">True</property>"
"                                <property name=\"label\" translatable=\"yes\" comments=\"Part of the phrase &quot;Draw right margin at column [XX]&quot;\">at column</property>"
"                              </widget>"
"                              <packing>"
"                                <property name=\"expand\">False</property>"
"                                <property name=\"fill\">False</property>"
"                                <property name=\"position\">0</property>"
"                              </packing>"
"                            </child>"
"                            <child>"
"                              <widget class=\"GtkSpinButton\" id=\"spin_right_margin_offset\">"
"                                <property name=\"visible\">True</property>"
"                                <property name=\"can_focus\">True</property>"
"                                <property name=\"adjustment\">80 1 1000 1 5 0</property>"
"                                <property name=\"numeric\">True</property>"
"                              </widget>"
"                              <packing>"
"                                <property name=\"expand\">False</property>"
"                                <property name=\"fill\">False</property>"
"                                <property name=\"position\">1</property>"
"                              </packing>"
"                            </child>"
"                          </widget>"
"                          <packing>"
"                            <property name=\"position\">1</property>"
"                          </packing>"
"                        </child>"
"                      </widget>"
"                      <packing>"
"                        <property name=\"expand\">False</property>"
"                        <property name=\"fill\">False</property>"
"                        <property name=\"position\">4</property>"
"                      </packing>"
"                    </child>"
"                  </widget>"
"                </child>"
"              </widget>"
"              <packing>"
"                <property name=\"expand\">False</property>"
"                <property name=\"fill\">False</property>"
"                <property name=\"position\">1</property>"
"              </packing>"
"            </child>"
"          </widget>"
"          <packing>"
"            <property name=\"expand\">False</property>"
"            <property name=\"fill\">False</property>"
"            <property name=\"position\">2</property>"
"          </packing>"
"        </child>"
"      </widget>"
"    </child>"
"  </widget>"
"</glade-interface>"

;

typedef struct PrefsViewXml PrefsViewXml;

struct PrefsViewXml {
    MooGladeXML *xml;

    GtkVBox *PrefsView;
    GtkCheckButton *enable_wrapping;
    GtkCheckButton *dont_split_words;
    GtkCheckButton *check_enable_highlighting;
    GtkCheckButton *check_highlight_matching_brackets;
    GtkCheckButton *check_highlight_mismatching_brackets;
    GtkCheckButton *check_highlight_current_line;
    GtkCheckButton *show_line_numbers;
    GtkCheckButton *check_show_tabs;
    GtkCheckButton *check_show_spaces;
    GtkCheckButton *check_show_trailing_spaces;
    GtkCheckButton *draw_rigth_margin;
    GtkHBox *right_margin_box;
    GtkSpinButton *spin_right_margin_offset;

};

static void
_prefs_view_xml_free (PrefsViewXml *xml)
{
    if (xml)
    {
        if (xml->xml)
            g_object_unref (xml->xml);
        g_free (xml);
    }
}

G_GNUC_UNUSED static PrefsViewXml *
prefs_view_xml_get (gpointer widget)
{
    return (PrefsViewXml*) g_object_get_data (G_OBJECT (widget), "moo-generated-glade-xml");
}

static gboolean
_prefs_view_xml_finish_build (PrefsViewXml *xml)
{
    g_return_val_if_fail(xml != NULL, FALSE);

    xml->PrefsView = (GtkVBox*) moo_glade_xml_get_widget (xml->xml, "PrefsView");
    g_return_val_if_fail (xml->PrefsView != NULL, FALSE);
    xml->enable_wrapping = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "enable_wrapping");
    g_return_val_if_fail (xml->enable_wrapping != NULL, FALSE);
    xml->dont_split_words = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "dont_split_words");
    g_return_val_if_fail (xml->dont_split_words != NULL, FALSE);
    xml->check_enable_highlighting = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "check_enable_highlighting");
    g_return_val_if_fail (xml->check_enable_highlighting != NULL, FALSE);
    xml->check_highlight_matching_brackets = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "check_highlight_matching_brackets");
    g_return_val_if_fail (xml->check_highlight_matching_brackets != NULL, FALSE);
    xml->check_highlight_mismatching_brackets = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "check_highlight_mismatching_brackets");
    g_return_val_if_fail (xml->check_highlight_mismatching_brackets != NULL, FALSE);
    xml->check_highlight_current_line = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "check_highlight_current_line");
    g_return_val_if_fail (xml->check_highlight_current_line != NULL, FALSE);
    xml->show_line_numbers = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "show_line_numbers");
    g_return_val_if_fail (xml->show_line_numbers != NULL, FALSE);
    xml->check_show_tabs = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "check_show_tabs");
    g_return_val_if_fail (xml->check_show_tabs != NULL, FALSE);
    xml->check_show_spaces = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "check_show_spaces");
    g_return_val_if_fail (xml->check_show_spaces != NULL, FALSE);
    xml->check_show_trailing_spaces = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "check_show_trailing_spaces");
    g_return_val_if_fail (xml->check_show_trailing_spaces != NULL, FALSE);
    xml->draw_rigth_margin = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "draw_rigth_margin");
    g_return_val_if_fail (xml->draw_rigth_margin != NULL, FALSE);
    xml->right_margin_box = (GtkHBox*) moo_glade_xml_get_widget (xml->xml, "right_margin_box");
    g_return_val_if_fail (xml->right_margin_box != NULL, FALSE);
    xml->spin_right_margin_offset = (GtkSpinButton*) moo_glade_xml_get_widget (xml->xml, "spin_right_margin_offset");
    g_return_val_if_fail (xml->spin_right_margin_offset != NULL, FALSE);

    g_object_set_data_full (G_OBJECT (xml->PrefsView), "moo-generated-glade-xml",
                            xml, (GDestroyNotify) _prefs_view_xml_free);
    return TRUE;
}

static gboolean
prefs_view_xml_build (PrefsViewXml *xml)
{
    GError *error = NULL;
    if (!moo_glade_xml_parse_memory (xml->xml, _prefs_view_xml_glade_xml, -1, "PrefsView", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _prefs_view_xml_finish_build (xml);
}

static gboolean
prefs_view_xml_fill (PrefsViewXml *xml, GtkWidget *root)
{
    GError *error = NULL;
    if (!moo_glade_xml_fill_widget (xml->xml, root, _prefs_view_xml_glade_xml, -1, "PrefsView", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _prefs_view_xml_finish_build (xml);
}

static PrefsViewXml *
prefs_view_xml_new_empty (void)
{
    PrefsViewXml *xml = g_new0 (PrefsViewXml, 1);
    xml->xml = moo_glade_xml_new_empty (GETTEXT_PACKAGE);

    return xml;
}

G_GNUC_UNUSED static PrefsViewXml *
prefs_view_xml_new (void)
{
    PrefsViewXml *xml = prefs_view_xml_new_empty ();
    if (!prefs_view_xml_build (xml))
    {
        _prefs_view_xml_free (xml);
        xml = NULL;
    }
    return xml;
}

G_GNUC_UNUSED static PrefsViewXml *
prefs_view_xml_new_with_root (GtkWidget *root)
{
    PrefsViewXml *xml = prefs_view_xml_new_empty ();
    if (!prefs_view_xml_fill (xml, root))
    {
        _prefs_view_xml_free (xml);
        xml = NULL;
    }
    return xml;
}
