#include <mooutils/mooglade.h>
#include <mooutils/mooi18n.h>
#include <gtk/gtk.h>

static const char _prefs_page_xml_glade_xml[] =
"<?xml version=\"1.0\"?>"
"<glade-interface>"
"  <requires-version lib=\"gtk+\" version=\"2.12\"/>"
"  <widget class=\"GtkWindow\" id=\"window1\">"
"    <property name=\"visible\">True</property>"
"    <property name=\"title\">window1</property>"
"    <child>"
"      <widget class=\"GtkVBox\" id=\"PrefsPage\">"
"        <property name=\"visible\">True</property>"
"        <property name=\"border_width\">12</property>"
"        <property name=\"spacing\">6</property>"
"        <child>"
"          <widget class=\"GtkScrolledWindow\" id=\"scrolledwindow1\">"
"            <property name=\"visible\">True</property>"
"            <property name=\"can_focus\">False</property>"
"            <property name=\"hscrollbar_policy\">GTK_POLICY_AUTOMATIC</property>"
"            <property name=\"vscrollbar_policy\">GTK_POLICY_AUTOMATIC</property>"
"            <property name=\"shadow_type\">GTK_SHADOW_IN</property>"
"            <child>"
"              <widget class=\"GtkTreeView\" id=\"treeview\">"
"                <property name=\"visible\">True</property>"
"              </widget>"
"            </child>"
"          </widget>"
"        </child>"
"        <child>"
"          <widget class=\"GtkTable\" id=\"info\">"
"            <property name=\"visible\">True</property>"
"            <property name=\"n_rows\">3</property>"
"            <property name=\"n_columns\">2</property>"
"            <property name=\"column_spacing\">6</property>"
"            <property name=\"row_spacing\">6</property>"
"            <child>"
"              <widget class=\"GtkLabel\" id=\"label1\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"xalign\">1</property>"
"                <property name=\"yalign\">0</property>"
"                <property name=\"label\" translatable=\"yes\">&lt;b&gt;Version:&lt;/b&gt;</property>"
"                <property name=\"use_markup\">True</property>"
"              </widget>"
"              <packing>"
"                <property name=\"x_options\">GTK_FILL</property>"
"                <property name=\"y_options\">GTK_FILL</property>"
"              </packing>"
"            </child>"
"            <child>"
"              <widget class=\"GtkLabel\" id=\"label2\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"xalign\">1</property>"
"                <property name=\"yalign\">0</property>"
"                <property name=\"label\" translatable=\"yes\">&lt;b&gt;Author:&lt;/b&gt;</property>"
"                <property name=\"use_markup\">True</property>"
"              </widget>"
"              <packing>"
"                <property name=\"top_attach\">1</property>"
"                <property name=\"bottom_attach\">2</property>"
"                <property name=\"x_options\">GTK_FILL</property>"
"                <property name=\"y_options\">GTK_FILL</property>"
"              </packing>"
"            </child>"
"            <child>"
"              <widget class=\"GtkLabel\" id=\"label3\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"xalign\">1</property>"
"                <property name=\"yalign\">0</property>"
"                <property name=\"label\" translatable=\"yes\">&lt;b&gt;Description:&lt;/b&gt;</property>"
"                <property name=\"use_markup\">True</property>"
"              </widget>"
"              <packing>"
"                <property name=\"top_attach\">2</property>"
"                <property name=\"bottom_attach\">3</property>"
"                <property name=\"x_options\">GTK_FILL</property>"
"                <property name=\"y_options\">GTK_FILL</property>"
"              </packing>"
"            </child>"
"            <child>"
"              <widget class=\"GtkLabel\" id=\"version\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"xalign\">0</property>"
"                <property name=\"yalign\">0</property>"
"                <property name=\"label\">0.15</property>"
"              </widget>"
"              <packing>"
"                <property name=\"left_attach\">1</property>"
"                <property name=\"right_attach\">2</property>"
"                <property name=\"y_options\">GTK_FILL</property>"
"              </packing>"
"            </child>"
"            <child>"
"              <widget class=\"GtkLabel\" id=\"author\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"xalign\">0</property>"
"                <property name=\"yalign\">0</property>"
"                <property name=\"label\">Some Guy</property>"
"              </widget>"
"              <packing>"
"                <property name=\"left_attach\">1</property>"
"                <property name=\"right_attach\">2</property>"
"                <property name=\"top_attach\">1</property>"
"                <property name=\"bottom_attach\">2</property>"
"                <property name=\"y_options\">GTK_FILL</property>"
"              </packing>"
"            </child>"
"            <child>"
"              <widget class=\"GtkLabel\" id=\"description\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"xalign\">0</property>"
"                <property name=\"yalign\">0</property>"
"                <property name=\"label\">It does some stuff</property>"
"                <property name=\"wrap\">True</property>"
"              </widget>"
"              <packing>"
"                <property name=\"left_attach\">1</property>"
"                <property name=\"right_attach\">2</property>"
"                <property name=\"top_attach\">2</property>"
"                <property name=\"bottom_attach\">3</property>"
"                <property name=\"y_options\">GTK_FILL</property>"
"              </packing>"
"            </child>"
"          </widget>"
"          <packing>"
"            <property name=\"expand\">False</property>"
"            <property name=\"fill\">False</property>"
"            <property name=\"position\">1</property>"
"          </packing>"
"        </child>"
"      </widget>"
"    </child>"
"  </widget>"
"</glade-interface>"

;

typedef struct PrefsPageXml PrefsPageXml;

struct PrefsPageXml {
    MooGladeXML *xml;

    GtkVBox *PrefsPage;
    GtkTreeView *treeview;
    GtkTable *info;
    GtkLabel *version;
    GtkLabel *author;
    GtkLabel *description;

};

static void
_prefs_page_xml_free (PrefsPageXml *xml)
{
    if (xml)
    {
        if (xml->xml)
            g_object_unref (xml->xml);
        g_free (xml);
    }
}

G_GNUC_UNUSED static PrefsPageXml *
prefs_page_xml_get (gpointer widget)
{
    return (PrefsPageXml*) g_object_get_data (G_OBJECT (widget), "moo-generated-glade-xml");
}

static gboolean
_prefs_page_xml_finish_build (PrefsPageXml *xml)
{
    g_return_val_if_fail(xml != NULL, FALSE);

    xml->PrefsPage = (GtkVBox*) moo_glade_xml_get_widget (xml->xml, "PrefsPage");
    g_return_val_if_fail (xml->PrefsPage != NULL, FALSE);
    xml->treeview = (GtkTreeView*) moo_glade_xml_get_widget (xml->xml, "treeview");
    g_return_val_if_fail (xml->treeview != NULL, FALSE);
    xml->info = (GtkTable*) moo_glade_xml_get_widget (xml->xml, "info");
    g_return_val_if_fail (xml->info != NULL, FALSE);
    xml->version = (GtkLabel*) moo_glade_xml_get_widget (xml->xml, "version");
    g_return_val_if_fail (xml->version != NULL, FALSE);
    xml->author = (GtkLabel*) moo_glade_xml_get_widget (xml->xml, "author");
    g_return_val_if_fail (xml->author != NULL, FALSE);
    xml->description = (GtkLabel*) moo_glade_xml_get_widget (xml->xml, "description");
    g_return_val_if_fail (xml->description != NULL, FALSE);

    g_object_set_data_full (G_OBJECT (xml->PrefsPage), "moo-generated-glade-xml",
                            xml, (GDestroyNotify) _prefs_page_xml_free);
    return TRUE;
}

static gboolean
prefs_page_xml_build (PrefsPageXml *xml)
{
    GError *error = NULL;
    if (!moo_glade_xml_parse_memory (xml->xml, _prefs_page_xml_glade_xml, -1, "PrefsPage", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _prefs_page_xml_finish_build (xml);
}

static gboolean
prefs_page_xml_fill (PrefsPageXml *xml, GtkWidget *root)
{
    GError *error = NULL;
    if (!moo_glade_xml_fill_widget (xml->xml, root, _prefs_page_xml_glade_xml, -1, "PrefsPage", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _prefs_page_xml_finish_build (xml);
}

static PrefsPageXml *
prefs_page_xml_new_empty (void)
{
    PrefsPageXml *xml = g_new0 (PrefsPageXml, 1);
    xml->xml = moo_glade_xml_new_empty (GETTEXT_PACKAGE);

    return xml;
}

G_GNUC_UNUSED static PrefsPageXml *
prefs_page_xml_new (void)
{
    PrefsPageXml *xml = prefs_page_xml_new_empty ();
    if (!prefs_page_xml_build (xml))
    {
        _prefs_page_xml_free (xml);
        xml = NULL;
    }
    return xml;
}

G_GNUC_UNUSED static PrefsPageXml *
prefs_page_xml_new_with_root (GtkWidget *root)
{
    PrefsPageXml *xml = prefs_page_xml_new_empty ();
    if (!prefs_page_xml_fill (xml, root))
    {
        _prefs_page_xml_free (xml);
        xml = NULL;
    }
    return xml;
}
