#include <mooutils/mooglade.h>
#include <mooutils/mooi18n.h>
#include <gtk/gtk.h>

static const char _print_widget_xml_glade_xml[] =
"<?xml version=\"1.0\"?>"
"<glade-interface>"
"  <widget class=\"GtkDialog\" id=\"dialog1\">"
"    <property name=\"title\">Print Options</property>"
"    <property name=\"type_hint\">GDK_WINDOW_TYPE_HINT_DIALOG</property>"
"    <child internal-child=\"vbox\">"
"      <widget class=\"GtkVBox\" id=\"dialog-vbox1\">"
"        <property name=\"visible\">True</property>"
"        <child>"
"          <widget class=\"GtkAlignment\" id=\"PrintWidget\">"
"            <property name=\"visible\">True</property>"
"            <property name=\"top_padding\">6</property>"
"            <property name=\"bottom_padding\">6</property>"
"            <property name=\"left_padding\">6</property>"
"            <property name=\"right_padding\">6</property>"
"            <child>"
"              <widget class=\"GtkVBox\" id=\"vbox\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"spacing\">6</property>"
"                <child>"
"                  <widget class=\"GtkCheckButton\" id=\"use_styles\">"
"                    <property name=\"visible\">True</property>"
"                    <property name=\"label\" translatable=\"yes\">Print using text styles</property>"
"                    <property name=\"use_underline\">True</property>"
"                    <property name=\"response_id\">0</property>"
"                    <property name=\"draw_indicator\">True</property>"
"                  </widget>"
"                  <packing>"
"                    <property name=\"expand\">False</property>"
"                    <property name=\"fill\">False</property>"
"                  </packing>"
"                </child>"
"                <child>"
"                  <widget class=\"GtkHBox\" id=\"hbox1\">"
"                    <property name=\"visible\">True</property>"
"                    <property name=\"spacing\">6</property>"
"                    <child>"
"                      <widget class=\"GtkCheckButton\" id=\"use_custom_font\">"
"                        <property name=\"visible\">True</property>"
"                        <property name=\"label\" translatable=\"yes\">Use custom font:</property>"
"                        <property name=\"use_underline\">True</property>"
"                        <property name=\"response_id\">0</property>"
"                        <property name=\"draw_indicator\">True</property>"
"                      </widget>"
"                      <packing>"
"                        <property name=\"expand\">False</property>"
"                        <property name=\"fill\">False</property>"
"                      </packing>"
"                    </child>"
"                    <child>"
"                      <widget class=\"GtkFontButton\" id=\"font\">"
"                        <property name=\"visible\">True</property>"
"                        <property name=\"response_id\">0</property>"
"                      </widget>"
"                      <packing>"
"                        <property name=\"expand\">False</property>"
"                        <property name=\"fill\">False</property>"
"                        <property name=\"position\">1</property>"
"                      </packing>"
"                    </child>"
"                  </widget>"
"                  <packing>"
"                    <property name=\"expand\">False</property>"
"                    <property name=\"fill\">False</property>"
"                    <property name=\"position\">1</property>"
"                  </packing>"
"                </child>"
"                <child>"
"                  <widget class=\"GtkCheckButton\" id=\"wrap\">"
"                    <property name=\"visible\">True</property>"
"                    <property name=\"label\" translatable=\"yes\">Wrap long lines</property>"
"                    <property name=\"use_underline\">True</property>"
"                    <property name=\"response_id\">0</property>"
"                    <property name=\"draw_indicator\">True</property>"
"                  </widget>"
"                  <packing>"
"                    <property name=\"expand\">False</property>"
"                    <property name=\"fill\">False</property>"
"                    <property name=\"position\">2</property>"
"                  </packing>"
"                </child>"
"                <child>"
"                  <widget class=\"GtkCheckButton\" id=\"ellipsize\">"
"                    <property name=\"visible\">True</property>"
"                    <property name=\"label\" translatable=\"yes\">Ellipsize long lines</property>"
"                    <property name=\"use_underline\">True</property>"
"                    <property name=\"response_id\">0</property>"
"                    <property name=\"draw_indicator\">True</property>"
"                  </widget>"
"                  <packing>"
"                    <property name=\"expand\">False</property>"
"                    <property name=\"fill\">False</property>"
"                    <property name=\"position\">3</property>"
"                  </packing>"
"                </child>"
"                <child>"
"                  <widget class=\"GtkHBox\" id=\"hbox2\">"
"                    <property name=\"visible\">True</property>"
"                    <child>"
"                      <widget class=\"GtkCheckButton\" id=\"line_numbers\">"
"                        <property name=\"visible\">True</property>"
"                        <property name=\"label\" translatable=\"yes\" comments=\"Part of the phrase &quot;Print line numbers&quot; &quot;every&quot; &quot;1&quot; &quot;lines&quot;\">Print line numbers</property>"
"                        <property name=\"response_id\">0</property>"
"                        <property name=\"draw_indicator\">True</property>"
"                      </widget>"
"                      <packing>"
"                        <property name=\"expand\">False</property>"
"                        <property name=\"fill\">False</property>"
"                      </packing>"
"                    </child>"
"                    <child>"
"                      <widget class=\"GtkHBox\" id=\"line_numbers_hbox\">"
"                        <property name=\"visible\">True</property>"
"                        <property name=\"spacing\">3</property>"
"                        <child>"
"                          <widget class=\"GtkLabel\" id=\"label10\">"
"                            <property name=\"visible\">True</property>"
"                            <property name=\"label\" translatable=\"yes\" comments=\"Part of the phrase &quot;Print line numbers&quot; &quot;every&quot; &quot;1&quot; &quot;lines&quot;\">every</property>"
"                          </widget>"
"                        </child>"
"                        <child>"
"                          <widget class=\"GtkSpinButton\" id=\"line_numbers_step\">"
"                            <property name=\"visible\">True</property>"
"                            <property name=\"adjustment\">1 1 100 1 10 0</property>"
"                            <property name=\"climb_rate\">1</property>"
"                            <property name=\"numeric\">True</property>"
"                          </widget>"
"                          <packing>"
"                            <property name=\"expand\">False</property>"
"                            <property name=\"fill\">False</property>"
"                            <property name=\"position\">1</property>"
"                          </packing>"
"                        </child>"
"                        <child>"
"                          <widget class=\"GtkLabel\" id=\"label9\">"
"                            <property name=\"visible\">True</property>"
"                            <property name=\"label\" translatable=\"yes\" comments=\"Part of the phrase &quot;Print line numbers&quot; &quot;every&quot; &quot;1&quot; &quot;lines&quot;\">lines</property>"
"                          </widget>"
"                          <packing>"
"                            <property name=\"expand\">False</property>"
"                            <property name=\"fill\">False</property>"
"                            <property name=\"position\">2</property>"
"                          </packing>"
"                        </child>"
"                      </widget>"
"                      <packing>"
"                        <property name=\"expand\">False</property>"
"                        <property name=\"fill\">False</property>"
"                        <property name=\"padding\">3</property>"
"                        <property name=\"position\">1</property>"
"                      </packing>"
"                    </child>"
"                  </widget>"
"                  <packing>"
"                    <property name=\"expand\">False</property>"
"                    <property name=\"fill\">False</property>"
"                    <property name=\"position\">4</property>"
"                  </packing>"
"                </child>"
"                <child>"
"                  <widget class=\"GtkNotebook\" id=\"notebook1\">"
"                    <property name=\"visible\">True</property>"
"                    <child>"
"                      <widget class=\"GtkAlignment\" id=\"alignment1\">"
"                        <property name=\"visible\">True</property>"
"                        <property name=\"top_padding\">6</property>"
"                        <property name=\"bottom_padding\">6</property>"
"                        <property name=\"left_padding\">6</property>"
"                        <property name=\"right_padding\">6</property>"
"                        <child>"
"                          <widget class=\"GtkVBox\" id=\"vbox1\">"
"                            <property name=\"visible\">True</property>"
"                            <property name=\"spacing\">6</property>"
"                            <child>"
"                              <widget class=\"GtkCheckButton\" id=\"print_header\">"
"                                <property name=\"visible\">True</property>"
"                                <property name=\"label\" translatable=\"yes\">Print header</property>"
"                                <property name=\"use_underline\">True</property>"
"                                <property name=\"response_id\">0</property>"
"                                <property name=\"draw_indicator\">True</property>"
"                              </widget>"
"                              <packing>"
"                                <property name=\"expand\">False</property>"
"                                <property name=\"fill\">False</property>"
"                              </packing>"
"                            </child>"
"                            <child>"
"                              <widget class=\"GtkAlignment\" id=\"header_alignment\">"
"                                <property name=\"visible\">True</property>"
"                                <child>"
"                                  <widget class=\"GtkVBox\" id=\"vbox2\">"
"                                    <property name=\"visible\">True</property>"
"                                    <property name=\"spacing\">6</property>"
"                                    <child>"
"                                      <widget class=\"GtkCheckButton\" id=\"header_separator\">"
"                                        <property name=\"visible\">True</property>"
"                                        <property name=\"label\" translatable=\"yes\">Print separator line</property>"
"                                        <property name=\"use_underline\">True</property>"
"                                        <property name=\"response_id\">0</property>"
"                                        <property name=\"draw_indicator\">True</property>"
"                                      </widget>"
"                                      <packing>"
"                                        <property name=\"expand\">False</property>"
"                                        <property name=\"fill\">False</property>"
"                                      </packing>"
"                                    </child>"
"                                    <child>"
"                                      <widget class=\"GtkTable\" id=\"table1\">"
"                                        <property name=\"visible\">True</property>"
"                                        <property name=\"n_rows\">3</property>"
"                                        <property name=\"n_columns\">2</property>"
"                                        <property name=\"column_spacing\">12</property>"
"                                        <property name=\"row_spacing\">6</property>"
"                                        <child>"
"                                          <widget class=\"GtkEntry\" id=\"header_right\">"
"                                            <property name=\"visible\">True</property>"
"                                            <property name=\"tooltip\">Format is similar to that of strftime (3), with the following additions:"
"%Ef - printed document name;"
"%EF - full path of printed document;"
"%Ep - current page number;"
"%EP - total number of pages.</property>"
"                                          </widget>"
"                                          <packing>"
"                                            <property name=\"left_attach\">1</property>"
"                                            <property name=\"right_attach\">2</property>"
"                                            <property name=\"top_attach\">2</property>"
"                                            <property name=\"bottom_attach\">3</property>"
"                                            <property name=\"y_options\"></property>"
"                                          </packing>"
"                                        </child>"
"                                        <child>"
"                                          <widget class=\"GtkEntry\" id=\"header_center\">"
"                                            <property name=\"visible\">True</property>"
"                                            <property name=\"tooltip\">Format is similar to that of strftime (3), with the following additions:"
"%Ef - printed document name;"
"%EF - full path of printed document;"
"%Ep - current page number;"
"%EP - total number of pages.</property>"
"                                          </widget>"
"                                          <packing>"
"                                            <property name=\"left_attach\">1</property>"
"                                            <property name=\"right_attach\">2</property>"
"                                            <property name=\"top_attach\">1</property>"
"                                            <property name=\"bottom_attach\">2</property>"
"                                            <property name=\"y_options\"></property>"
"                                          </packing>"
"                                        </child>"
"                                        <child>"
"                                          <widget class=\"GtkEntry\" id=\"header_left\">"
"                                            <property name=\"visible\">True</property>"
"                                            <property name=\"tooltip\">Format is similar to that of strftime (3), with the following additions:"
"%Ef - printed document name;"
"%EF - full path of printed document;"
"%Ep - current page number;"
"%EP - total number of pages.</property>"
"                                          </widget>"
"                                          <packing>"
"                                            <property name=\"left_attach\">1</property>"
"                                            <property name=\"right_attach\">2</property>"
"                                            <property name=\"y_options\"></property>"
"                                          </packing>"
"                                        </child>"
"                                        <child>"
"                                          <widget class=\"GtkLabel\" id=\"label5\">"
"                                            <property name=\"visible\">True</property>"
"                                            <property name=\"xalign\">0</property>"
"                                            <property name=\"label\" translatable=\"yes\">Right:</property>"
"                                          </widget>"
"                                          <packing>"
"                                            <property name=\"top_attach\">2</property>"
"                                            <property name=\"bottom_attach\">3</property>"
"                                            <property name=\"x_options\">GTK_FILL</property>"
"                                            <property name=\"y_options\"></property>"
"                                          </packing>"
"                                        </child>"
"                                        <child>"
"                                          <widget class=\"GtkLabel\" id=\"label4\">"
"                                            <property name=\"visible\">True</property>"
"                                            <property name=\"xalign\">0</property>"
"                                            <property name=\"label\" translatable=\"yes\">Center:</property>"
"                                          </widget>"
"                                          <packing>"
"                                            <property name=\"top_attach\">1</property>"
"                                            <property name=\"bottom_attach\">2</property>"
"                                            <property name=\"x_options\">GTK_FILL</property>"
"                                            <property name=\"y_options\"></property>"
"                                          </packing>"
"                                        </child>"
"                                        <child>"
"                                          <widget class=\"GtkLabel\" id=\"label3\">"
"                                            <property name=\"visible\">True</property>"
"                                            <property name=\"xalign\">0</property>"
"                                            <property name=\"label\" translatable=\"yes\">Left:</property>"
"                                          </widget>"
"                                          <packing>"
"                                            <property name=\"x_options\">GTK_FILL</property>"
"                                            <property name=\"y_options\"></property>"
"                                          </packing>"
"                                        </child>"
"                                      </widget>"
"                                      <packing>"
"                                        <property name=\"expand\">False</property>"
"                                        <property name=\"position\">1</property>"
"                                      </packing>"
"                                    </child>"
"                                  </widget>"
"                                </child>"
"                              </widget>"
"                              <packing>"
"                                <property name=\"position\">1</property>"
"                              </packing>"
"                            </child>"
"                          </widget>"
"                        </child>"
"                      </widget>"
"                    </child>"
"                    <child>"
"                      <widget class=\"GtkLabel\" id=\"label1\">"
"                        <property name=\"visible\">True</property>"
"                        <property name=\"label\" translatable=\"yes\">Header</property>"
"                      </widget>"
"                      <packing>"
"                        <property name=\"tab_fill\">False</property>"
"                        <property name=\"type\">tab</property>"
"                      </packing>"
"                    </child>"
"                    <child>"
"                      <widget class=\"GtkAlignment\" id=\"alignment3\">"
"                        <property name=\"visible\">True</property>"
"                        <property name=\"top_padding\">6</property>"
"                        <property name=\"bottom_padding\">6</property>"
"                        <property name=\"left_padding\">6</property>"
"                        <property name=\"right_padding\">6</property>"
"                        <child>"
"                          <widget class=\"GtkVBox\" id=\"vbox7\">"
"                            <property name=\"visible\">True</property>"
"                            <property name=\"spacing\">6</property>"
"                            <child>"
"                              <widget class=\"GtkCheckButton\" id=\"print_footer\">"
"                                <property name=\"visible\">True</property>"
"                                <property name=\"label\" translatable=\"yes\">Print footer</property>"
"                                <property name=\"use_underline\">True</property>"
"                                <property name=\"response_id\">0</property>"
"                                <property name=\"draw_indicator\">True</property>"
"                              </widget>"
"                              <packing>"
"                                <property name=\"expand\">False</property>"
"                                <property name=\"fill\">False</property>"
"                              </packing>"
"                            </child>"
"                            <child>"
"                              <widget class=\"GtkAlignment\" id=\"footer_alignment\">"
"                                <property name=\"visible\">True</property>"
"                                <child>"
"                                  <widget class=\"GtkVBox\" id=\"vbox8\">"
"                                    <property name=\"visible\">True</property>"
"                                    <property name=\"spacing\">6</property>"
"                                    <child>"
"                                      <widget class=\"GtkCheckButton\" id=\"footer_separator\">"
"                                        <property name=\"visible\">True</property>"
"                                        <property name=\"label\" translatable=\"yes\">Print separator line</property>"
"                                        <property name=\"use_underline\">True</property>"
"                                        <property name=\"response_id\">0</property>"
"                                        <property name=\"draw_indicator\">True</property>"
"                                      </widget>"
"                                      <packing>"
"                                        <property name=\"expand\">False</property>"
"                                        <property name=\"fill\">False</property>"
"                                      </packing>"
"                                    </child>"
"                                    <child>"
"                                      <widget class=\"GtkTable\" id=\"table4\">"
"                                        <property name=\"visible\">True</property>"
"                                        <property name=\"n_rows\">3</property>"
"                                        <property name=\"n_columns\">2</property>"
"                                        <property name=\"column_spacing\">12</property>"
"                                        <property name=\"row_spacing\">6</property>"
"                                        <child>"
"                                          <widget class=\"GtkEntry\" id=\"footer_right\">"
"                                            <property name=\"visible\">True</property>"
"                                            <property name=\"tooltip\">Format is similar to that of strftime (3), with the following additions:"
"%Ef - printed document name;"
"%EF - full path of printed document;"
"%Ep - current page number;"
"%EP - total number of pages.</property>"
"                                          </widget>"
"                                          <packing>"
"                                            <property name=\"left_attach\">1</property>"
"                                            <property name=\"right_attach\">2</property>"
"                                            <property name=\"top_attach\">2</property>"
"                                            <property name=\"bottom_attach\">3</property>"
"                                            <property name=\"y_options\"></property>"
"                                          </packing>"
"                                        </child>"
"                                        <child>"
"                                          <widget class=\"GtkEntry\" id=\"footer_center\">"
"                                            <property name=\"visible\">True</property>"
"                                            <property name=\"tooltip\">Format is similar to that of strftime (3), with the following additions:"
"%Ef - printed document name;"
"%EF - full path of printed document;"
"%Ep - current page number;"
"%EP - total number of pages.</property>"
"                                          </widget>"
"                                          <packing>"
"                                            <property name=\"left_attach\">1</property>"
"                                            <property name=\"right_attach\">2</property>"
"                                            <property name=\"top_attach\">1</property>"
"                                            <property name=\"bottom_attach\">2</property>"
"                                            <property name=\"y_options\"></property>"
"                                          </packing>"
"                                        </child>"
"                                        <child>"
"                                          <widget class=\"GtkEntry\" id=\"footer_left\">"
"                                            <property name=\"visible\">True</property>"
"                                            <property name=\"tooltip\">Format is similar to that of strftime (3), with the following additions:"
"%Ef - printed document name;"
"%EF - full path of printed document;"
"%Ep - current page number;"
"%EP - total number of pages.</property>"
"                                          </widget>"
"                                          <packing>"
"                                            <property name=\"left_attach\">1</property>"
"                                            <property name=\"right_attach\">2</property>"
"                                            <property name=\"y_options\"></property>"
"                                          </packing>"
"                                        </child>"
"                                        <child>"
"                                          <widget class=\"GtkLabel\" id=\"label14\">"
"                                            <property name=\"visible\">True</property>"
"                                            <property name=\"xalign\">0</property>"
"                                            <property name=\"label\" translatable=\"yes\">Right:</property>"
"                                          </widget>"
"                                          <packing>"
"                                            <property name=\"top_attach\">2</property>"
"                                            <property name=\"bottom_attach\">3</property>"
"                                            <property name=\"x_options\">GTK_FILL</property>"
"                                            <property name=\"y_options\"></property>"
"                                          </packing>"
"                                        </child>"
"                                        <child>"
"                                          <widget class=\"GtkLabel\" id=\"label15\">"
"                                            <property name=\"visible\">True</property>"
"                                            <property name=\"xalign\">0</property>"
"                                            <property name=\"label\" translatable=\"yes\">Center:</property>"
"                                          </widget>"
"                                          <packing>"
"                                            <property name=\"top_attach\">1</property>"
"                                            <property name=\"bottom_attach\">2</property>"
"                                            <property name=\"x_options\">GTK_FILL</property>"
"                                            <property name=\"y_options\"></property>"
"                                          </packing>"
"                                        </child>"
"                                        <child>"
"                                          <widget class=\"GtkLabel\" id=\"label16\">"
"                                            <property name=\"visible\">True</property>"
"                                            <property name=\"xalign\">0</property>"
"                                            <property name=\"label\" translatable=\"yes\">Left:</property>"
"                                          </widget>"
"                                          <packing>"
"                                            <property name=\"x_options\">GTK_FILL</property>"
"                                            <property name=\"y_options\"></property>"
"                                          </packing>"
"                                        </child>"
"                                      </widget>"
"                                      <packing>"
"                                        <property name=\"expand\">False</property>"
"                                        <property name=\"position\">1</property>"
"                                      </packing>"
"                                    </child>"
"                                  </widget>"
"                                </child>"
"                              </widget>"
"                              <packing>"
"                                <property name=\"position\">1</property>"
"                              </packing>"
"                            </child>"
"                          </widget>"
"                        </child>"
"                      </widget>"
"                      <packing>"
"                        <property name=\"position\">1</property>"
"                      </packing>"
"                    </child>"
"                    <child>"
"                      <widget class=\"GtkLabel\" id=\"label2\">"
"                        <property name=\"visible\">True</property>"
"                        <property name=\"label\" translatable=\"yes\">Footer</property>"
"                      </widget>"
"                      <packing>"
"                        <property name=\"position\">1</property>"
"                        <property name=\"tab_fill\">False</property>"
"                        <property name=\"type\">tab</property>"
"                      </packing>"
"                    </child>"
"                  </widget>"
"                  <packing>"
"                    <property name=\"expand\">False</property>"
"                    <property name=\"fill\">False</property>"
"                    <property name=\"position\">5</property>"
"                  </packing>"
"                </child>"
"              </widget>"
"            </child>"
"          </widget>"
"          <packing>"
"            <property name=\"position\">2</property>"
"          </packing>"
"        </child>"
"        <child internal-child=\"action_area\">"
"          <widget class=\"GtkHButtonBox\" id=\"dialog-action_area1\">"
"            <property name=\"visible\">True</property>"
"            <property name=\"layout_style\">GTK_BUTTONBOX_END</property>"
"            <child>"
"              <widget class=\"GtkButton\" id=\"cancelbutton1\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"can_default\">True</property>"
"                <property name=\"label\">gtk-cancel</property>"
"                <property name=\"use_stock\">True</property>"
"                <property name=\"focus_on_click\">False</property>"
"                <property name=\"response_id\">-6</property>"
"              </widget>"
"            </child>"
"            <child>"
"              <widget class=\"GtkButton\" id=\"okbutton1\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"can_default\">True</property>"
"                <property name=\"label\">gtk-ok</property>"
"                <property name=\"use_stock\">True</property>"
"                <property name=\"focus_on_click\">False</property>"
"                <property name=\"response_id\">-5</property>"
"              </widget>"
"              <packing>"
"                <property name=\"position\">1</property>"
"              </packing>"
"            </child>"
"          </widget>"
"          <packing>"
"            <property name=\"expand\">False</property>"
"            <property name=\"pack_type\">GTK_PACK_END</property>"
"          </packing>"
"        </child>"
"      </widget>"
"    </child>"
"  </widget>"
"</glade-interface>"

;

typedef struct PrintWidgetXml PrintWidgetXml;

struct PrintWidgetXml {
    MooGladeXML *xml;

    GtkAlignment *PrintWidget;
    GtkVBox *vbox;
    GtkCheckButton *use_styles;
    GtkCheckButton *use_custom_font;
    GtkFontButton *font;
    GtkCheckButton *wrap;
    GtkCheckButton *ellipsize;
    GtkCheckButton *line_numbers;
    GtkHBox *line_numbers_hbox;
    GtkSpinButton *line_numbers_step;
    GtkCheckButton *print_header;
    GtkAlignment *header_alignment;
    GtkCheckButton *header_separator;
    GtkEntry *header_right;
    GtkEntry *header_center;
    GtkEntry *header_left;
    GtkCheckButton *print_footer;
    GtkAlignment *footer_alignment;
    GtkCheckButton *footer_separator;
    GtkEntry *footer_right;
    GtkEntry *footer_center;
    GtkEntry *footer_left;

};

static void
_print_widget_xml_free (PrintWidgetXml *xml)
{
    if (xml)
    {
        if (xml->xml)
            g_object_unref (xml->xml);
        g_free (xml);
    }
}

G_GNUC_UNUSED static PrintWidgetXml *
print_widget_xml_get (gpointer widget)
{
    return (PrintWidgetXml*) g_object_get_data (G_OBJECT (widget), "moo-generated-glade-xml");
}

static gboolean
_print_widget_xml_finish_build (PrintWidgetXml *xml)
{
    g_return_val_if_fail(xml != NULL, FALSE);

    xml->PrintWidget = (GtkAlignment*) moo_glade_xml_get_widget (xml->xml, "PrintWidget");
    g_return_val_if_fail (xml->PrintWidget != NULL, FALSE);
    xml->vbox = (GtkVBox*) moo_glade_xml_get_widget (xml->xml, "vbox");
    g_return_val_if_fail (xml->vbox != NULL, FALSE);
    xml->use_styles = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "use_styles");
    g_return_val_if_fail (xml->use_styles != NULL, FALSE);
    xml->use_custom_font = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "use_custom_font");
    g_return_val_if_fail (xml->use_custom_font != NULL, FALSE);
    xml->font = (GtkFontButton*) moo_glade_xml_get_widget (xml->xml, "font");
    g_return_val_if_fail (xml->font != NULL, FALSE);
    xml->wrap = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "wrap");
    g_return_val_if_fail (xml->wrap != NULL, FALSE);
    xml->ellipsize = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "ellipsize");
    g_return_val_if_fail (xml->ellipsize != NULL, FALSE);
    xml->line_numbers = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "line_numbers");
    g_return_val_if_fail (xml->line_numbers != NULL, FALSE);
    xml->line_numbers_hbox = (GtkHBox*) moo_glade_xml_get_widget (xml->xml, "line_numbers_hbox");
    g_return_val_if_fail (xml->line_numbers_hbox != NULL, FALSE);
    xml->line_numbers_step = (GtkSpinButton*) moo_glade_xml_get_widget (xml->xml, "line_numbers_step");
    g_return_val_if_fail (xml->line_numbers_step != NULL, FALSE);
    xml->print_header = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "print_header");
    g_return_val_if_fail (xml->print_header != NULL, FALSE);
    xml->header_alignment = (GtkAlignment*) moo_glade_xml_get_widget (xml->xml, "header_alignment");
    g_return_val_if_fail (xml->header_alignment != NULL, FALSE);
    xml->header_separator = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "header_separator");
    g_return_val_if_fail (xml->header_separator != NULL, FALSE);
    xml->header_right = (GtkEntry*) moo_glade_xml_get_widget (xml->xml, "header_right");
    g_return_val_if_fail (xml->header_right != NULL, FALSE);
    xml->header_center = (GtkEntry*) moo_glade_xml_get_widget (xml->xml, "header_center");
    g_return_val_if_fail (xml->header_center != NULL, FALSE);
    xml->header_left = (GtkEntry*) moo_glade_xml_get_widget (xml->xml, "header_left");
    g_return_val_if_fail (xml->header_left != NULL, FALSE);
    xml->print_footer = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "print_footer");
    g_return_val_if_fail (xml->print_footer != NULL, FALSE);
    xml->footer_alignment = (GtkAlignment*) moo_glade_xml_get_widget (xml->xml, "footer_alignment");
    g_return_val_if_fail (xml->footer_alignment != NULL, FALSE);
    xml->footer_separator = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "footer_separator");
    g_return_val_if_fail (xml->footer_separator != NULL, FALSE);
    xml->footer_right = (GtkEntry*) moo_glade_xml_get_widget (xml->xml, "footer_right");
    g_return_val_if_fail (xml->footer_right != NULL, FALSE);
    xml->footer_center = (GtkEntry*) moo_glade_xml_get_widget (xml->xml, "footer_center");
    g_return_val_if_fail (xml->footer_center != NULL, FALSE);
    xml->footer_left = (GtkEntry*) moo_glade_xml_get_widget (xml->xml, "footer_left");
    g_return_val_if_fail (xml->footer_left != NULL, FALSE);

    g_object_set_data_full (G_OBJECT (xml->PrintWidget), "moo-generated-glade-xml",
                            xml, (GDestroyNotify) _print_widget_xml_free);
    return TRUE;
}

static gboolean
print_widget_xml_build (PrintWidgetXml *xml)
{
    GError *error = NULL;
    if (!moo_glade_xml_parse_memory (xml->xml, _print_widget_xml_glade_xml, -1, "PrintWidget", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _print_widget_xml_finish_build (xml);
}

static gboolean
print_widget_xml_fill (PrintWidgetXml *xml, GtkWidget *root)
{
    GError *error = NULL;
    if (!moo_glade_xml_fill_widget (xml->xml, root, _print_widget_xml_glade_xml, -1, "PrintWidget", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _print_widget_xml_finish_build (xml);
}

static PrintWidgetXml *
print_widget_xml_new_empty (void)
{
    PrintWidgetXml *xml = g_new0 (PrintWidgetXml, 1);
    xml->xml = moo_glade_xml_new_empty (GETTEXT_PACKAGE);

    return xml;
}

G_GNUC_UNUSED static PrintWidgetXml *
print_widget_xml_new (void)
{
    PrintWidgetXml *xml = print_widget_xml_new_empty ();
    if (!print_widget_xml_build (xml))
    {
        _print_widget_xml_free (xml);
        xml = NULL;
    }
    return xml;
}

G_GNUC_UNUSED static PrintWidgetXml *
print_widget_xml_new_with_root (GtkWidget *root)
{
    PrintWidgetXml *xml = print_widget_xml_new_empty ();
    if (!print_widget_xml_fill (xml, root))
    {
        _print_widget_xml_free (xml);
        xml = NULL;
    }
    return xml;
}
