#include <mooutils/mooglade.h>
#include <mooutils/mooi18n.h>
#include <gtk/gtk.h>

static const char mooprintpreview_glade_xml[] =
"<?xml version=\"1.0\"?>"
"<glade-interface>"
"  <requires-version lib=\"gtk+\" version=\"2.12\"/>"
"  <widget class=\"GtkWindow\" id=\"window1\">"
"    <property name=\"visible\">True</property>"
"    <property name=\"title\">window1</property>"
"    <child>"
"      <widget class=\"GtkHBox\" id=\"PageEntry\">"
"        <property name=\"visible\">True</property>"
"        <property name=\"spacing\">3</property>"
"        <child>"
"          <widget class=\"GtkEntry\" id=\"entry\">"
"            <property name=\"visible\">True</property>"
"            <property name=\"width_chars\">5</property>"
"          </widget>"
"          <packing>"
"            <property name=\"expand\">False</property>"
"          </packing>"
"        </child>"
"        <child>"
"          <widget class=\"GtkLabel\" id=\"label\">"
"            <property name=\"visible\">True</property>"
"            <property name=\"label\">of 8</property>"
"          </widget>"
"          <packing>"
"            <property name=\"expand\">False</property>"
"            <property name=\"position\">1</property>"
"          </packing>"
"        </child>"
"      </widget>"
"    </child>"
"  </widget>"
"  <widget class=\"GtkDialog\" id=\"PrintPreview\">"
"    <property name=\"visible\">True</property>"
"    <property name=\"title\">Print Preview</property>"
"    <property name=\"default_width\">800</property>"
"    <property name=\"default_height\">600</property>"
"    <property name=\"type_hint\">GDK_WINDOW_TYPE_HINT_DIALOG</property>"
"    <child internal-child=\"vbox\">"
"      <widget class=\"GtkVBox\" id=\"dialog-vbox1\">"
"        <property name=\"visible\">True</property>"
"        <child>"
"          <widget class=\"GtkVBox\" id=\"vbox1\">"
"            <property name=\"visible\">True</property>"
"            <child>"
"              <widget class=\"GtkToolbar\" id=\"toolbar\">"
"                <property name=\"visible\">True</property>"
"                <child>"
"                  <widget class=\"GtkToolButton\" id=\"prev\">"
"                    <property name=\"visible\">True</property>"
"                    <property name=\"is_important\">True</property>"
"                    <property name=\"stock_id\">gtk-go-back</property>"
"                  </widget>"
"                  <packing>"
"                    <property name=\"expand\">False</property>"
"                  </packing>"
"                </child>"
"                <child>"
"                  <widget class=\"GtkToolButton\" id=\"next\">"
"                    <property name=\"visible\">True</property>"
"                    <property name=\"is_important\">True</property>"
"                    <property name=\"stock_id\">gtk-go-forward</property>"
"                  </widget>"
"                  <packing>"
"                    <property name=\"expand\">False</property>"
"                  </packing>"
"                </child>"
"                <child>"
"                  <widget class=\"GtkSeparatorToolItem\" id=\"separatortoolitem1\">"
"                    <property name=\"visible\">True</property>"
"                  </widget>"
"                  <packing>"
"                    <property name=\"expand\">False</property>"
"                    <property name=\"homogeneous\">False</property>"
"                  </packing>"
"                </child>"
"                <child>"
"                  <widget class=\"GtkToolItem\" id=\"entry_item\">"
"                    <property name=\"visible\">True</property>"
"                    <property name=\"is_important\">True</property>"
"                  </widget>"
"                  <packing>"
"                    <property name=\"expand\">False</property>"
"                    <property name=\"homogeneous\">False</property>"
"                  </packing>"
"                </child>"
"                <child>"
"                  <widget class=\"GtkSeparatorToolItem\" id=\"separatortoolitem2\"/>"
"                  <packing>"
"                    <property name=\"expand\">False</property>"
"                    <property name=\"homogeneous\">False</property>"
"                  </packing>"
"                </child>"
"                <child>"
"                  <widget class=\"GtkToolButton\" id=\"zoom_normal\">"
"                    <property name=\"visible\">True</property>"
"                    <property name=\"stock_id\">gtk-zoom-100</property>"
"                  </widget>"
"                  <packing>"
"                    <property name=\"expand\">False</property>"
"                  </packing>"
"                </child>"
"                <child>"
"                  <widget class=\"GtkToolButton\" id=\"zoom_to_fit\">"
"                    <property name=\"visible\">True</property>"
"                    <property name=\"stock_id\">gtk-zoom-fit</property>"
"                  </widget>"
"                  <packing>"
"                    <property name=\"expand\">False</property>"
"                  </packing>"
"                </child>"
"                <child>"
"                  <widget class=\"GtkToolButton\" id=\"zoom_out\">"
"                    <property name=\"stock_id\">gtk-zoom-out</property>"
"                  </widget>"
"                  <packing>"
"                    <property name=\"expand\">False</property>"
"                  </packing>"
"                </child>"
"                <child>"
"                  <widget class=\"GtkToolButton\" id=\"zoom_in\">"
"                    <property name=\"stock_id\">gtk-zoom-in</property>"
"                  </widget>"
"                  <packing>"
"                    <property name=\"expand\">False</property>"
"                  </packing>"
"                </child>"
"              </widget>"
"              <packing>"
"                <property name=\"expand\">False</property>"
"                <property name=\"fill\">False</property>"
"              </packing>"
"            </child>"
"            <child>"
"              <widget class=\"GtkScrolledWindow\" id=\"swin\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"can_focus\">False</property>"
"                <property name=\"hscrollbar_policy\">GTK_POLICY_AUTOMATIC</property>"
"                <property name=\"vscrollbar_policy\">GTK_POLICY_AUTOMATIC</property>"
"                <property name=\"shadow_type\">GTK_SHADOW_ETCHED_IN</property>"
"                <child>"
"                  <widget class=\"GtkViewport\" id=\"viewport1\">"
"                    <property name=\"visible\">True</property>"
"                    <child>"
"                      <widget class=\"GtkDrawingArea\" id=\"darea\">"
"                        <property name=\"visible\">True</property>"
"                      </widget>"
"                    </child>"
"                  </widget>"
"                </child>"
"              </widget>"
"              <packing>"
"                <property name=\"position\">1</property>"
"              </packing>"
"            </child>"
"          </widget>"
"          <packing>"
"            <property name=\"position\">2</property>"
"          </packing>"
"        </child>"
"        <child internal-child=\"action_area\">"
"          <widget class=\"GtkHButtonBox\" id=\"dialog-action_area1\">"
"            <property name=\"visible\">True</property>"
"            <property name=\"layout_style\">GTK_BUTTONBOX_END</property>"
"            <child>"
"              <widget class=\"GtkButton\" id=\"button1\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"can_default\">True</property>"
"                <property name=\"label\">gtk-close</property>"
"                <property name=\"use_stock\">True</property>"
"                <property name=\"focus_on_click\">False</property>"
"                <property name=\"response_id\">-7</property>"
"              </widget>"
"            </child>"
"            <child>"
"              <widget class=\"GtkButton\" id=\"button2\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"can_default\">True</property>"
"                <property name=\"has_default\">True</property>"
"                <property name=\"focus_on_click\">False</property>"
"                <property name=\"response_id\">-10</property>"
"                <child>"
"                  <widget class=\"GtkAlignment\" id=\"alignment1\">"
"                    <property name=\"visible\">True</property>"
"                    <property name=\"xscale\">0</property>"
"                    <property name=\"yscale\">0</property>"
"                    <child>"
"                      <widget class=\"GtkHBox\" id=\"hbox1\">"
"                        <property name=\"visible\">True</property>"
"                        <property name=\"spacing\">2</property>"
"                        <child>"
"                          <widget class=\"GtkImage\" id=\"image1\">"
"                            <property name=\"visible\">True</property>"
"                            <property name=\"stock\">gtk-print</property>"
"                          </widget>"
"                          <packing>"
"                            <property name=\"expand\">False</property>"
"                            <property name=\"fill\">False</property>"
"                          </packing>"
"                        </child>"
"                        <child>"
"                          <widget class=\"GtkLabel\" id=\"label1\">"
"                            <property name=\"visible\">True</property>"
"                            <property name=\"label\" translatable=\"yes\">Print...</property>"
"                            <property name=\"use_underline\">True</property>"
"                          </widget>"
"                          <packing>"
"                            <property name=\"expand\">False</property>"
"                            <property name=\"fill\">False</property>"
"                            <property name=\"position\">1</property>"
"                          </packing>"
"                        </child>"
"                      </widget>"
"                    </child>"
"                  </widget>"
"                </child>"
"              </widget>"
"              <packing>"
"                <property name=\"position\">1</property>"
"              </packing>"
"            </child>"
"          </widget>"
"          <packing>"
"            <property name=\"expand\">False</property>"
"            <property name=\"pack_type\">GTK_PACK_END</property>"
"          </packing>"
"        </child>"
"      </widget>"
"    </child>"
"  </widget>"
"</glade-interface>"

;

typedef struct PageEntryXml PageEntryXml;

struct PageEntryXml {
    MooGladeXML *xml;

    GtkHBox *PageEntry;
    GtkEntry *entry;
    GtkLabel *label;

};

static void
_page_entry_xml_free (PageEntryXml *xml)
{
    if (xml)
    {
        if (xml->xml)
            g_object_unref (xml->xml);
        g_free (xml);
    }
}

G_GNUC_UNUSED static PageEntryXml *
page_entry_xml_get (gpointer widget)
{
    return (PageEntryXml*) g_object_get_data (G_OBJECT (widget), "moo-generated-glade-xml");
}

static gboolean
_page_entry_xml_finish_build (PageEntryXml *xml)
{
    g_return_val_if_fail(xml != NULL, FALSE);

    xml->PageEntry = (GtkHBox*) moo_glade_xml_get_widget (xml->xml, "PageEntry");
    g_return_val_if_fail (xml->PageEntry != NULL, FALSE);
    xml->entry = (GtkEntry*) moo_glade_xml_get_widget (xml->xml, "entry");
    g_return_val_if_fail (xml->entry != NULL, FALSE);
    xml->label = (GtkLabel*) moo_glade_xml_get_widget (xml->xml, "label");
    g_return_val_if_fail (xml->label != NULL, FALSE);

    g_object_set_data_full (G_OBJECT (xml->PageEntry), "moo-generated-glade-xml",
                            xml, (GDestroyNotify) _page_entry_xml_free);
    return TRUE;
}

static gboolean
page_entry_xml_build (PageEntryXml *xml)
{
    GError *error = NULL;
    if (!moo_glade_xml_parse_memory (xml->xml, mooprintpreview_glade_xml, -1, "PageEntry", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _page_entry_xml_finish_build (xml);
}

static gboolean
page_entry_xml_fill (PageEntryXml *xml, GtkWidget *root)
{
    GError *error = NULL;
    if (!moo_glade_xml_fill_widget (xml->xml, root, mooprintpreview_glade_xml, -1, "PageEntry", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _page_entry_xml_finish_build (xml);
}

static PageEntryXml *
page_entry_xml_new_empty (void)
{
    PageEntryXml *xml = g_new0 (PageEntryXml, 1);
    xml->xml = moo_glade_xml_new_empty (GETTEXT_PACKAGE);

    return xml;
}

G_GNUC_UNUSED static PageEntryXml *
page_entry_xml_new (void)
{
    PageEntryXml *xml = page_entry_xml_new_empty ();
    if (!page_entry_xml_build (xml))
    {
        _page_entry_xml_free (xml);
        xml = NULL;
    }
    return xml;
}

G_GNUC_UNUSED static PageEntryXml *
page_entry_xml_new_with_root (GtkWidget *root)
{
    PageEntryXml *xml = page_entry_xml_new_empty ();
    if (!page_entry_xml_fill (xml, root))
    {
        _page_entry_xml_free (xml);
        xml = NULL;
    }
    return xml;
}
typedef struct PrintPreviewXml PrintPreviewXml;

struct PrintPreviewXml {
    MooGladeXML *xml;

    GtkDialog *PrintPreview;
    GtkToolbar *toolbar;
    GtkToolButton *prev;
    GtkToolButton *next;
    GtkToolItem *entry_item;
    GtkToolButton *zoom_normal;
    GtkToolButton *zoom_to_fit;
    GtkToolButton *zoom_out;
    GtkToolButton *zoom_in;
    GtkScrolledWindow *swin;
    GtkDrawingArea *darea;

};

static void
_print_preview_xml_free (PrintPreviewXml *xml)
{
    if (xml)
    {
        if (xml->xml)
            g_object_unref (xml->xml);
        g_free (xml);
    }
}

G_GNUC_UNUSED static PrintPreviewXml *
print_preview_xml_get (gpointer widget)
{
    return (PrintPreviewXml*) g_object_get_data (G_OBJECT (widget), "moo-generated-glade-xml");
}

static gboolean
_print_preview_xml_finish_build (PrintPreviewXml *xml)
{
    g_return_val_if_fail(xml != NULL, FALSE);

    xml->PrintPreview = (GtkDialog*) moo_glade_xml_get_widget (xml->xml, "PrintPreview");
    g_return_val_if_fail (xml->PrintPreview != NULL, FALSE);
    xml->toolbar = (GtkToolbar*) moo_glade_xml_get_widget (xml->xml, "toolbar");
    g_return_val_if_fail (xml->toolbar != NULL, FALSE);
    xml->prev = (GtkToolButton*) moo_glade_xml_get_widget (xml->xml, "prev");
    g_return_val_if_fail (xml->prev != NULL, FALSE);
    xml->next = (GtkToolButton*) moo_glade_xml_get_widget (xml->xml, "next");
    g_return_val_if_fail (xml->next != NULL, FALSE);
    xml->entry_item = (GtkToolItem*) moo_glade_xml_get_widget (xml->xml, "entry_item");
    g_return_val_if_fail (xml->entry_item != NULL, FALSE);
    xml->zoom_normal = (GtkToolButton*) moo_glade_xml_get_widget (xml->xml, "zoom_normal");
    g_return_val_if_fail (xml->zoom_normal != NULL, FALSE);
    xml->zoom_to_fit = (GtkToolButton*) moo_glade_xml_get_widget (xml->xml, "zoom_to_fit");
    g_return_val_if_fail (xml->zoom_to_fit != NULL, FALSE);
    xml->zoom_out = (GtkToolButton*) moo_glade_xml_get_widget (xml->xml, "zoom_out");
    g_return_val_if_fail (xml->zoom_out != NULL, FALSE);
    xml->zoom_in = (GtkToolButton*) moo_glade_xml_get_widget (xml->xml, "zoom_in");
    g_return_val_if_fail (xml->zoom_in != NULL, FALSE);
    xml->swin = (GtkScrolledWindow*) moo_glade_xml_get_widget (xml->xml, "swin");
    g_return_val_if_fail (xml->swin != NULL, FALSE);
    xml->darea = (GtkDrawingArea*) moo_glade_xml_get_widget (xml->xml, "darea");
    g_return_val_if_fail (xml->darea != NULL, FALSE);

    g_object_set_data_full (G_OBJECT (xml->PrintPreview), "moo-generated-glade-xml",
                            xml, (GDestroyNotify) _print_preview_xml_free);
    return TRUE;
}

static gboolean
print_preview_xml_build (PrintPreviewXml *xml)
{
    GError *error = NULL;
    if (!moo_glade_xml_parse_memory (xml->xml, mooprintpreview_glade_xml, -1, "PrintPreview", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _print_preview_xml_finish_build (xml);
}

static gboolean
print_preview_xml_fill (PrintPreviewXml *xml, GtkWidget *root)
{
    GError *error = NULL;
    if (!moo_glade_xml_fill_widget (xml->xml, root, mooprintpreview_glade_xml, -1, "PrintPreview", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _print_preview_xml_finish_build (xml);
}

static PrintPreviewXml *
print_preview_xml_new_empty (void)
{
    PrintPreviewXml *xml = g_new0 (PrintPreviewXml, 1);
    xml->xml = moo_glade_xml_new_empty (GETTEXT_PACKAGE);

    return xml;
}

G_GNUC_UNUSED static PrintPreviewXml *
print_preview_xml_new (void)
{
    PrintPreviewXml *xml = print_preview_xml_new_empty ();
    if (!print_preview_xml_build (xml))
    {
        _print_preview_xml_free (xml);
        xml = NULL;
    }
    return xml;
}

G_GNUC_UNUSED static PrintPreviewXml *
print_preview_xml_new_with_root (GtkWidget *root)
{
    PrintPreviewXml *xml = print_preview_xml_new_empty ();
    if (!print_preview_xml_fill (xml, root))
    {
        _print_preview_xml_free (xml);
        xml = NULL;
    }
    return xml;
}
