#include <mooutils/mooglade.h>
#include <mooutils/mooi18n.h>
#include <gtk/gtk.h>

static const char _find_prompt_dialog_xml_glade_xml[] =
"<?xml version=\"1.0\"?>"
"<glade-interface>"
"  <widget class=\"GtkDialog\" id=\"FindPromptDialog\">"
"    <property name=\"title\">Replace?</property>"
"    <property name=\"type_hint\">GDK_WINDOW_TYPE_HINT_DIALOG</property>"
"    <property name=\"has_separator\">False</property>"
"    <child internal-child=\"vbox\">"
"      <widget class=\"GtkVBox\" id=\"dialog-vbox3\">"
"        <property name=\"visible\">True</property>"
"        <child>"
"          <widget class=\"GtkLabel\" id=\"label7\">"
"            <property name=\"visible\">True</property>"
"            <property name=\"label\" translatable=\"yes\">Replace?</property>"
"          </widget>"
"          <packing>"
"            <property name=\"expand\">False</property>"
"            <property name=\"fill\">False</property>"
"            <property name=\"position\">1</property>"
"          </packing>"
"        </child>"
"        <child internal-child=\"action_area\">"
"          <widget class=\"GtkHButtonBox\" id=\"dialog-action_area3\">"
"            <property name=\"visible\">True</property>"
"            <property name=\"layout_style\">GTK_BUTTONBOX_END</property>"
"            <child>"
"              <widget class=\"GtkButton\" id=\"button1\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"can_default\">True</property>"
"                <property name=\"has_default\">True</property>"
"                <property name=\"label\" translatable=\"yes\">_Replace</property>"
"                <property name=\"use_underline\">True</property>"
"                <property name=\"focus_on_click\">False</property>"
"                <property name=\"response_id\">2</property>"
"              </widget>"
"            </child>"
"            <child>"
"              <widget class=\"GtkButton\" id=\"button3\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"can_default\">True</property>"
"                <property name=\"label\" translatable=\"yes\">Replace _All</property>"
"                <property name=\"use_underline\">True</property>"
"                <property name=\"focus_on_click\">False</property>"
"                <property name=\"response_id\">3</property>"
"              </widget>"
"              <packing>"
"                <property name=\"position\">1</property>"
"              </packing>"
"            </child>"
"            <child>"
"              <widget class=\"GtkButton\" id=\"button4\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"can_default\">True</property>"
"                <property name=\"label\" translatable=\"yes\">Find _Next</property>"
"                <property name=\"use_underline\">True</property>"
"                <property name=\"focus_on_click\">False</property>"
"                <property name=\"response_id\">1</property>"
"              </widget>"
"              <packing>"
"                <property name=\"position\">2</property>"
"              </packing>"
"            </child>"
"            <child>"
"              <widget class=\"GtkButton\" id=\"button5\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"can_default\">True</property>"
"                <property name=\"label\" translatable=\"yes\">Sto_p</property>"
"                <property name=\"use_underline\">True</property>"
"                <property name=\"focus_on_click\">False</property>"
"                <property name=\"response_id\">0</property>"
"              </widget>"
"              <packing>"
"                <property name=\"position\">3</property>"
"              </packing>"
"            </child>"
"          </widget>"
"          <packing>"
"            <property name=\"expand\">False</property>"
"            <property name=\"fill\">False</property>"
"            <property name=\"pack_type\">GTK_PACK_END</property>"
"          </packing>"
"        </child>"
"      </widget>"
"    </child>"
"  </widget>"
"</glade-interface>"

;

typedef struct FindPromptDialogXml FindPromptDialogXml;

struct FindPromptDialogXml {
    MooGladeXML *xml;

    GtkDialog *FindPromptDialog;

};

static void
_find_prompt_dialog_xml_free (FindPromptDialogXml *xml)
{
    if (xml)
    {
        if (xml->xml)
            g_object_unref (xml->xml);
        g_free (xml);
    }
}

G_GNUC_UNUSED static FindPromptDialogXml *
find_prompt_dialog_xml_get (gpointer widget)
{
    return (FindPromptDialogXml*) g_object_get_data (G_OBJECT (widget), "moo-generated-glade-xml");
}

static gboolean
_find_prompt_dialog_xml_finish_build (FindPromptDialogXml *xml)
{
    g_return_val_if_fail(xml != NULL, FALSE);

    xml->FindPromptDialog = (GtkDialog*) moo_glade_xml_get_widget (xml->xml, "FindPromptDialog");
    g_return_val_if_fail (xml->FindPromptDialog != NULL, FALSE);

    g_object_set_data_full (G_OBJECT (xml->FindPromptDialog), "moo-generated-glade-xml",
                            xml, (GDestroyNotify) _find_prompt_dialog_xml_free);
    return TRUE;
}

static gboolean
find_prompt_dialog_xml_build (FindPromptDialogXml *xml)
{
    GError *error = NULL;
    if (!moo_glade_xml_parse_memory (xml->xml, _find_prompt_dialog_xml_glade_xml, -1, "FindPromptDialog", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _find_prompt_dialog_xml_finish_build (xml);
}

static gboolean
find_prompt_dialog_xml_fill (FindPromptDialogXml *xml, GtkWidget *root)
{
    GError *error = NULL;
    if (!moo_glade_xml_fill_widget (xml->xml, root, _find_prompt_dialog_xml_glade_xml, -1, "FindPromptDialog", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _find_prompt_dialog_xml_finish_build (xml);
}

static FindPromptDialogXml *
find_prompt_dialog_xml_new_empty (void)
{
    FindPromptDialogXml *xml = g_new0 (FindPromptDialogXml, 1);
    xml->xml = moo_glade_xml_new_empty (GETTEXT_PACKAGE);

    return xml;
}

G_GNUC_UNUSED static FindPromptDialogXml *
find_prompt_dialog_xml_new (void)
{
    FindPromptDialogXml *xml = find_prompt_dialog_xml_new_empty ();
    if (!find_prompt_dialog_xml_build (xml))
    {
        _find_prompt_dialog_xml_free (xml);
        xml = NULL;
    }
    return xml;
}

G_GNUC_UNUSED static FindPromptDialogXml *
find_prompt_dialog_xml_new_with_root (GtkWidget *root)
{
    FindPromptDialogXml *xml = find_prompt_dialog_xml_new_empty ();
    if (!find_prompt_dialog_xml_fill (xml, root))
    {
        _find_prompt_dialog_xml_free (xml);
        xml = NULL;
    }
    return xml;
}
