#include <mooutils/mooglade.h>
#include <mooutils/mooi18n.h>
#include <gtk/gtk.h>

static const char _moo_file_props_xml_glade_xml[] =
"<?xml version=\"1.0\"?>"
"<glade-interface>"
"  <requires-version lib=\"gtk+\" version=\"2.12\"/>"
"  <widget class=\"GtkDialog\" id=\"dialog1\">"
"    <property name=\"visible\">True</property>"
"    <property name=\"title\">dialog1</property>"
"    <property name=\"type_hint\">GDK_WINDOW_TYPE_HINT_DIALOG</property>"
"    <property name=\"has_separator\">False</property>"
"    <child internal-child=\"vbox\">"
"      <widget class=\"GtkVBox\" id=\"dialog-vbox1\">"
"        <property name=\"visible\">True</property>"
"        <child>"
"          <widget class=\"GtkNotebook\" id=\"MooFileProps\">"
"            <property name=\"visible\">True</property>"
"            <child>"
"              <widget class=\"GtkVBox\" id=\"vbox2\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"border_width\">6</property>"
"                <property name=\"spacing\">6</property>"
"                <child>"
"                  <widget class=\"GtkHBox\" id=\"hbox1\">"
"                    <property name=\"visible\">True</property>"
"                    <property name=\"spacing\">6</property>"
"                    <child>"
"                      <widget class=\"GtkImage\" id=\"icon\">"
"                        <property name=\"visible\">True</property>"
"                        <property name=\"stock\">gtk-directory</property>"
"                        <property name=\"icon_size\">6</property>"
"                      </widget>"
"                      <packing>"
"                        <property name=\"expand\">False</property>"
"                      </packing>"
"                    </child>"
"                    <child>"
"                      <widget class=\"GtkEntry\" id=\"entry:MooEntry\">"
"                        <property name=\"visible\">True</property>"
"                        <property name=\"has_focus\">True</property>"
"                        <property name=\"activates_default\">True</property>"
"                      </widget>"
"                      <packing>"
"                        <property name=\"position\">1</property>"
"                      </packing>"
"                    </child>"
"                  </widget>"
"                  <packing>"
"                    <property name=\"expand\">False</property>"
"                    <property name=\"fill\">False</property>"
"                  </packing>"
"                </child>"
"                <child>"
"                  <widget class=\"GtkTable\" id=\"table\">"
"                    <property name=\"visible\">True</property>"
"                    <property name=\"n_rows\">3</property>"
"                    <property name=\"n_columns\">2</property>"
"                    <property name=\"column_spacing\">6</property>"
"                    <property name=\"row_spacing\">6</property>"
"                    <child>"
"                      <placeholder/>"
"                    </child>"
"                    <child>"
"                      <placeholder/>"
"                    </child>"
"                    <child>"
"                      <placeholder/>"
"                    </child>"
"                    <child>"
"                      <placeholder/>"
"                    </child>"
"                    <child>"
"                      <placeholder/>"
"                    </child>"
"                    <child>"
"                      <placeholder/>"
"                    </child>"
"                  </widget>"
"                  <packing>"
"                    <property name=\"position\">1</property>"
"                  </packing>"
"                </child>"
"              </widget>"
"            </child>"
"            <child>"
"              <widget class=\"GtkLabel\" id=\"label1\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"label\" translatable=\"yes\">General</property>"
"              </widget>"
"              <packing>"
"                <property name=\"tab_fill\">False</property>"
"                <property name=\"type\">tab</property>"
"              </packing>"
"            </child>"
"          </widget>"
"          <packing>"
"            <property name=\"position\">1</property>"
"          </packing>"
"        </child>"
"        <child internal-child=\"action_area\">"
"          <widget class=\"GtkHButtonBox\" id=\"dialog-action_area1\">"
"            <property name=\"visible\">True</property>"
"            <property name=\"layout_style\">GTK_BUTTONBOX_END</property>"
"            <child>"
"              <widget class=\"GtkButton\" id=\"cancelbutton1\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"can_default\">True</property>"
"                <property name=\"label\">gtk-cancel</property>"
"                <property name=\"use_stock\">True</property>"
"                <property name=\"focus_on_click\">False</property>"
"                <property name=\"response_id\">-6</property>"
"              </widget>"
"            </child>"
"            <child>"
"              <widget class=\"GtkButton\" id=\"okbutton1\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"can_default\">True</property>"
"                <property name=\"has_default\">True</property>"
"                <property name=\"label\">gtk-ok</property>"
"                <property name=\"use_stock\">True</property>"
"                <property name=\"focus_on_click\">False</property>"
"                <property name=\"response_id\">-5</property>"
"              </widget>"
"              <packing>"
"                <property name=\"position\">1</property>"
"              </packing>"
"            </child>"
"          </widget>"
"          <packing>"
"            <property name=\"expand\">False</property>"
"            <property name=\"pack_type\">GTK_PACK_END</property>"
"          </packing>"
"        </child>"
"      </widget>"
"    </child>"
"  </widget>"
"</glade-interface>"

;

typedef struct MooFilePropsXml MooFilePropsXml;

struct MooFilePropsXml {
    MooGladeXML *xml;

    GtkNotebook *MooFileProps;
    GtkImage *icon;
    MooEntry *entry;
    GtkTable *table;

};

static void
_moo_file_props_xml_free (MooFilePropsXml *xml)
{
    if (xml)
    {
        if (xml->xml)
            g_object_unref (xml->xml);
        g_free (xml);
    }
}

G_GNUC_UNUSED static MooFilePropsXml *
moo_file_props_xml_get (gpointer widget)
{
    return (MooFilePropsXml*) g_object_get_data (G_OBJECT (widget), "moo-generated-glade-xml");
}

static gboolean
_moo_file_props_xml_finish_build (MooFilePropsXml *xml)
{
    g_return_val_if_fail(xml != NULL, FALSE);

    xml->MooFileProps = (GtkNotebook*) moo_glade_xml_get_widget (xml->xml, "MooFileProps");
    g_return_val_if_fail (xml->MooFileProps != NULL, FALSE);
    xml->icon = (GtkImage*) moo_glade_xml_get_widget (xml->xml, "icon");
    g_return_val_if_fail (xml->icon != NULL, FALSE);
    xml->entry = (MooEntry*) moo_glade_xml_get_widget (xml->xml, "entry:MooEntry");
    g_return_val_if_fail (xml->entry != NULL, FALSE);
    xml->table = (GtkTable*) moo_glade_xml_get_widget (xml->xml, "table");
    g_return_val_if_fail (xml->table != NULL, FALSE);

    g_object_set_data_full (G_OBJECT (xml->MooFileProps), "moo-generated-glade-xml",
                            xml, (GDestroyNotify) _moo_file_props_xml_free);
    return TRUE;
}

static gboolean
moo_file_props_xml_build (MooFilePropsXml *xml)
{
    GError *error = NULL;
    if (!moo_glade_xml_parse_memory (xml->xml, _moo_file_props_xml_glade_xml, -1, "MooFileProps", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _moo_file_props_xml_finish_build (xml);
}

static gboolean
moo_file_props_xml_fill (MooFilePropsXml *xml, GtkWidget *root)
{
    GError *error = NULL;
    if (!moo_glade_xml_fill_widget (xml->xml, root, _moo_file_props_xml_glade_xml, -1, "MooFileProps", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _moo_file_props_xml_finish_build (xml);
}

static MooFilePropsXml *
moo_file_props_xml_new_empty (void)
{
    MooFilePropsXml *xml = g_new0 (MooFilePropsXml, 1);
    xml->xml = moo_glade_xml_new_empty (GETTEXT_PACKAGE);

    return xml;
}

G_GNUC_UNUSED static MooFilePropsXml *
moo_file_props_xml_new (void)
{
    MooFilePropsXml *xml = moo_file_props_xml_new_empty ();
    if (!moo_file_props_xml_build (xml))
    {
        _moo_file_props_xml_free (xml);
        xml = NULL;
    }
    return xml;
}

G_GNUC_UNUSED static MooFilePropsXml *
moo_file_props_xml_new_with_root (GtkWidget *root)
{
    MooFilePropsXml *xml = moo_file_props_xml_new_empty ();
    if (!moo_file_props_xml_fill (xml, root))
    {
        _moo_file_props_xml_free (xml);
        xml = NULL;
    }
    return xml;
}
