#include <mooutils/mooglade.h>
#include <mooutils/mooi18n.h>
#include <gtk/gtk.h>

static const char moofileselector_glade_xml[] =
"<?xml version=\"1.0\"?>"
"<glade-interface>"
"  <requires-version lib=\"gtk+\" version=\"2.12\"/>"
"  <widget class=\"GtkDialog\" id=\"SaveAsDialog\">"
"    <property name=\"title\" translatable=\"yes\">Save As</property>"
"    <property name=\"window_position\">GTK_WIN_POS_MOUSE</property>"
"    <property name=\"type_hint\">GDK_WINDOW_TYPE_HINT_DIALOG</property>"
"    <property name=\"has_separator\">False</property>"
"    <child internal-child=\"vbox\">"
"      <widget class=\"GtkVBox\" id=\"dialog-vbox1\">"
"        <property name=\"visible\">True</property>"
"        <child>"
"          <widget class=\"GtkAlignment\" id=\"alignment1\">"
"            <property name=\"visible\">True</property>"
"            <property name=\"top_padding\">6</property>"
"            <property name=\"bottom_padding\">6</property>"
"            <property name=\"left_padding\">6</property>"
"            <property name=\"right_padding\">6</property>"
"            <child>"
"              <widget class=\"GtkVBox\" id=\"vbox1\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"spacing\">6</property>"
"                <child>"
"                  <widget class=\"GtkLabel\" id=\"label1\">"
"                    <property name=\"visible\">True</property>"
"                    <property name=\"xalign\">0</property>"
"                    <property name=\"label\" translatable=\"yes\">Save as</property>"
"                  </widget>"
"                  <packing>"
"                    <property name=\"expand\">False</property>"
"                    <property name=\"fill\">False</property>"
"                  </packing>"
"                </child>"
"                <child>"
"                  <widget class=\"GtkEntry\" id=\"entry:MooEntry\">"
"                    <property name=\"visible\">True</property>"
"                    <property name=\"can_focus\">True</property>"
"                    <property name=\"activates_default\">True</property>"
"                  </widget>"
"                  <packing>"
"                    <property name=\"expand\">False</property>"
"                    <property name=\"fill\">False</property>"
"                    <property name=\"position\">1</property>"
"                  </packing>"
"                </child>"
"              </widget>"
"            </child>"
"          </widget>"
"          <packing>"
"            <property name=\"position\">1</property>"
"          </packing>"
"        </child>"
"        <child internal-child=\"action_area\">"
"          <widget class=\"GtkHButtonBox\" id=\"dialog-action_area1\">"
"            <property name=\"visible\">True</property>"
"            <property name=\"layout_style\">GTK_BUTTONBOX_END</property>"
"            <child>"
"              <widget class=\"GtkButton\" id=\"cancelbutton1\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"can_default\">True</property>"
"                <property name=\"label\">gtk-cancel</property>"
"                <property name=\"use_stock\">True</property>"
"                <property name=\"response_id\">-6</property>"
"              </widget>"
"            </child>"
"            <child>"
"              <widget class=\"GtkButton\" id=\"ok_button\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"can_default\">True</property>"
"                <property name=\"has_default\">True</property>"
"                <property name=\"label\">gtk-ok</property>"
"                <property name=\"use_stock\">True</property>"
"                <property name=\"response_id\">-5</property>"
"              </widget>"
"              <packing>"
"                <property name=\"position\">1</property>"
"              </packing>"
"            </child>"
"          </widget>"
"          <packing>"
"            <property name=\"expand\">False</property>"
"            <property name=\"pack_type\">GTK_PACK_END</property>"
"          </packing>"
"        </child>"
"      </widget>"
"    </child>"
"  </widget>"
"  <widget class=\"GtkDialog\" id=\"NewFileDialog\">"
"    <property name=\"title\" translatable=\"yes\">Create File</property>"
"    <property name=\"window_position\">GTK_WIN_POS_MOUSE</property>"
"    <property name=\"type_hint\">GDK_WINDOW_TYPE_HINT_DIALOG</property>"
"    <property name=\"has_separator\">False</property>"
"    <child internal-child=\"vbox\">"
"      <widget class=\"GtkVBox\" id=\"dialog-vbox2\">"
"        <property name=\"visible\">True</property>"
"        <child>"
"          <widget class=\"GtkAlignment\" id=\"alignment2\">"
"            <property name=\"visible\">True</property>"
"            <property name=\"top_padding\">6</property>"
"            <property name=\"bottom_padding\">6</property>"
"            <property name=\"left_padding\">6</property>"
"            <property name=\"right_padding\">6</property>"
"            <child>"
"              <widget class=\"GtkVBox\" id=\"vbox3\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"spacing\">6</property>"
"                <child>"
"                  <widget class=\"GtkLabel\" id=\"label\">"
"                    <property name=\"xalign\">0</property>"
"                    <property name=\"label\">File name:</property>"
"                  </widget>"
"                  <packing>"
"                    <property name=\"expand\">False</property>"
"                    <property name=\"fill\">False</property>"
"                  </packing>"
"                </child>"
"                <child>"
"                  <widget class=\"GtkEntry\" id=\"entry:MooEntry\">"
"                    <property name=\"visible\">True</property>"
"                    <property name=\"activates_default\">True</property>"
"                  </widget>"
"                  <packing>"
"                    <property name=\"expand\">False</property>"
"                    <property name=\"fill\">False</property>"
"                    <property name=\"position\">1</property>"
"                  </packing>"
"                </child>"
"              </widget>"
"            </child>"
"          </widget>"
"          <packing>"
"            <property name=\"position\">1</property>"
"          </packing>"
"        </child>"
"        <child internal-child=\"action_area\">"
"          <widget class=\"GtkHButtonBox\" id=\"dialog-action_area2\">"
"            <property name=\"visible\">True</property>"
"            <property name=\"layout_style\">GTK_BUTTONBOX_END</property>"
"            <child>"
"              <widget class=\"GtkButton\" id=\"button1\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"can_default\">True</property>"
"                <property name=\"label\">gtk-cancel</property>"
"                <property name=\"use_stock\">True</property>"
"                <property name=\"response_id\">-6</property>"
"              </widget>"
"            </child>"
"            <child>"
"              <widget class=\"GtkButton\" id=\"ok_button\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"can_default\">True</property>"
"                <property name=\"has_default\">True</property>"
"                <property name=\"label\">gtk-ok</property>"
"                <property name=\"use_stock\">True</property>"
"                <property name=\"response_id\">-5</property>"
"              </widget>"
"              <packing>"
"                <property name=\"position\">1</property>"
"              </packing>"
"            </child>"
"          </widget>"
"          <packing>"
"            <property name=\"expand\">False</property>"
"            <property name=\"pack_type\">GTK_PACK_END</property>"
"          </packing>"
"        </child>"
"      </widget>"
"    </child>"
"  </widget>"
"</glade-interface>"

;

typedef struct SaveAsDialogXml SaveAsDialogXml;

struct SaveAsDialogXml {
    MooGladeXML *xml;

    GtkDialog *SaveAsDialog;
    MooEntry *entry;
    GtkButton *ok_button;

};

static void
_save_as_dialog_xml_free (SaveAsDialogXml *xml)
{
    if (xml)
    {
        if (xml->xml)
            g_object_unref (xml->xml);
        g_free (xml);
    }
}

G_GNUC_UNUSED static SaveAsDialogXml *
save_as_dialog_xml_get (gpointer widget)
{
    return (SaveAsDialogXml*) g_object_get_data (G_OBJECT (widget), "moo-generated-glade-xml");
}

static gboolean
_save_as_dialog_xml_finish_build (SaveAsDialogXml *xml)
{
    g_return_val_if_fail(xml != NULL, FALSE);

    xml->SaveAsDialog = (GtkDialog*) moo_glade_xml_get_widget (xml->xml, "SaveAsDialog");
    g_return_val_if_fail (xml->SaveAsDialog != NULL, FALSE);
    xml->entry = (MooEntry*) moo_glade_xml_get_widget (xml->xml, "entry:MooEntry");
    g_return_val_if_fail (xml->entry != NULL, FALSE);
    xml->ok_button = (GtkButton*) moo_glade_xml_get_widget (xml->xml, "ok_button");
    g_return_val_if_fail (xml->ok_button != NULL, FALSE);

    g_object_set_data_full (G_OBJECT (xml->SaveAsDialog), "moo-generated-glade-xml",
                            xml, (GDestroyNotify) _save_as_dialog_xml_free);
    return TRUE;
}

static gboolean
save_as_dialog_xml_build (SaveAsDialogXml *xml)
{
    GError *error = NULL;
    if (!moo_glade_xml_parse_memory (xml->xml, moofileselector_glade_xml, -1, "SaveAsDialog", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _save_as_dialog_xml_finish_build (xml);
}

static gboolean
save_as_dialog_xml_fill (SaveAsDialogXml *xml, GtkWidget *root)
{
    GError *error = NULL;
    if (!moo_glade_xml_fill_widget (xml->xml, root, moofileselector_glade_xml, -1, "SaveAsDialog", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _save_as_dialog_xml_finish_build (xml);
}

static SaveAsDialogXml *
save_as_dialog_xml_new_empty (void)
{
    SaveAsDialogXml *xml = g_new0 (SaveAsDialogXml, 1);
    xml->xml = moo_glade_xml_new_empty (GETTEXT_PACKAGE);

    return xml;
}

G_GNUC_UNUSED static SaveAsDialogXml *
save_as_dialog_xml_new (void)
{
    SaveAsDialogXml *xml = save_as_dialog_xml_new_empty ();
    if (!save_as_dialog_xml_build (xml))
    {
        _save_as_dialog_xml_free (xml);
        xml = NULL;
    }
    return xml;
}

G_GNUC_UNUSED static SaveAsDialogXml *
save_as_dialog_xml_new_with_root (GtkWidget *root)
{
    SaveAsDialogXml *xml = save_as_dialog_xml_new_empty ();
    if (!save_as_dialog_xml_fill (xml, root))
    {
        _save_as_dialog_xml_free (xml);
        xml = NULL;
    }
    return xml;
}
typedef struct NewFileDialogXml NewFileDialogXml;

struct NewFileDialogXml {
    MooGladeXML *xml;

    GtkDialog *NewFileDialog;
    GtkLabel *label;
    MooEntry *entry;
    GtkButton *ok_button;

};

static void
_new_file_dialog_xml_free (NewFileDialogXml *xml)
{
    if (xml)
    {
        if (xml->xml)
            g_object_unref (xml->xml);
        g_free (xml);
    }
}

G_GNUC_UNUSED static NewFileDialogXml *
new_file_dialog_xml_get (gpointer widget)
{
    return (NewFileDialogXml*) g_object_get_data (G_OBJECT (widget), "moo-generated-glade-xml");
}

static gboolean
_new_file_dialog_xml_finish_build (NewFileDialogXml *xml)
{
    g_return_val_if_fail(xml != NULL, FALSE);

    xml->NewFileDialog = (GtkDialog*) moo_glade_xml_get_widget (xml->xml, "NewFileDialog");
    g_return_val_if_fail (xml->NewFileDialog != NULL, FALSE);
    xml->label = (GtkLabel*) moo_glade_xml_get_widget (xml->xml, "label");
    g_return_val_if_fail (xml->label != NULL, FALSE);
    xml->entry = (MooEntry*) moo_glade_xml_get_widget (xml->xml, "entry:MooEntry");
    g_return_val_if_fail (xml->entry != NULL, FALSE);
    xml->ok_button = (GtkButton*) moo_glade_xml_get_widget (xml->xml, "ok_button");
    g_return_val_if_fail (xml->ok_button != NULL, FALSE);

    g_object_set_data_full (G_OBJECT (xml->NewFileDialog), "moo-generated-glade-xml",
                            xml, (GDestroyNotify) _new_file_dialog_xml_free);
    return TRUE;
}

static gboolean
new_file_dialog_xml_build (NewFileDialogXml *xml)
{
    GError *error = NULL;
    if (!moo_glade_xml_parse_memory (xml->xml, moofileselector_glade_xml, -1, "NewFileDialog", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _new_file_dialog_xml_finish_build (xml);
}

static gboolean
new_file_dialog_xml_fill (NewFileDialogXml *xml, GtkWidget *root)
{
    GError *error = NULL;
    if (!moo_glade_xml_fill_widget (xml->xml, root, moofileselector_glade_xml, -1, "NewFileDialog", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _new_file_dialog_xml_finish_build (xml);
}

static NewFileDialogXml *
new_file_dialog_xml_new_empty (void)
{
    NewFileDialogXml *xml = g_new0 (NewFileDialogXml, 1);
    xml->xml = moo_glade_xml_new_empty (GETTEXT_PACKAGE);

    return xml;
}

G_GNUC_UNUSED static NewFileDialogXml *
new_file_dialog_xml_new (void)
{
    NewFileDialogXml *xml = new_file_dialog_xml_new_empty ();
    if (!new_file_dialog_xml_build (xml))
    {
        _new_file_dialog_xml_free (xml);
        xml = NULL;
    }
    return xml;
}

G_GNUC_UNUSED static NewFileDialogXml *
new_file_dialog_xml_new_with_root (GtkWidget *root)
{
    NewFileDialogXml *xml = new_file_dialog_xml_new_empty ();
    if (!new_file_dialog_xml_fill (xml, root))
    {
        _new_file_dialog_xml_free (xml);
        xml = NULL;
    }
    return xml;
}
