#include <mooutils/mooglade.h>
#include <mooutils/mooi18n.h>
#include <gtk/gtk.h>

static const char _lua_page_xml_glade_xml[] =
"<?xml version=\"1.0\"?>"
"<glade-interface>"
"  <widget class=\"GtkWindow\" id=\"window2\">"
"    <property name=\"visible\">True</property>"
"    <property name=\"title\">window2</property>"
"    <child>"
"      <widget class=\"GtkVBox\" id=\"LuaPage\">"
"        <property name=\"visible\">True</property>"
"        <child>"
"          <widget class=\"GtkScrolledWindow\" id=\"scrolledwindow2\">"
"            <property name=\"visible\">True</property>"
"            <property name=\"can_focus\">False</property>"
"            <property name=\"hscrollbar_policy\">GTK_POLICY_AUTOMATIC</property>"
"            <property name=\"vscrollbar_policy\">GTK_POLICY_AUTOMATIC</property>"
"            <property name=\"shadow_type\">GTK_SHADOW_ETCHED_IN</property>"
"            <child>"
"              <widget class=\"GtkTextView\" id=\"textview:MooTextView\">"
"                <property name=\"visible\">True</property>"
"              </widget>"
"            </child>"
"          </widget>"
"        </child>"
"      </widget>"
"    </child>"
"  </widget>"
"</glade-interface>"

;

typedef struct LuaPageXml LuaPageXml;

struct LuaPageXml {
    MooGladeXML *xml;

    GtkVBox *LuaPage;
    MooTextView *textview;

};

static void
_lua_page_xml_free (LuaPageXml *xml)
{
    if (xml)
    {
        if (xml->xml)
            g_object_unref (xml->xml);
        g_free (xml);
    }
}

G_GNUC_UNUSED static LuaPageXml *
lua_page_xml_get (gpointer widget)
{
    return (LuaPageXml*) g_object_get_data (G_OBJECT (widget), "moo-generated-glade-xml");
}

static gboolean
_lua_page_xml_finish_build (LuaPageXml *xml)
{
    g_return_val_if_fail(xml != NULL, FALSE);

    xml->LuaPage = (GtkVBox*) moo_glade_xml_get_widget (xml->xml, "LuaPage");
    g_return_val_if_fail (xml->LuaPage != NULL, FALSE);
    xml->textview = (MooTextView*) moo_glade_xml_get_widget (xml->xml, "textview:MooTextView");
    g_return_val_if_fail (xml->textview != NULL, FALSE);

    g_object_set_data_full (G_OBJECT (xml->LuaPage), "moo-generated-glade-xml",
                            xml, (GDestroyNotify) _lua_page_xml_free);
    return TRUE;
}

static gboolean
lua_page_xml_build (LuaPageXml *xml)
{
    GError *error = NULL;
    if (!moo_glade_xml_parse_memory (xml->xml, _lua_page_xml_glade_xml, -1, "LuaPage", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _lua_page_xml_finish_build (xml);
}

static gboolean
lua_page_xml_fill (LuaPageXml *xml, GtkWidget *root)
{
    GError *error = NULL;
    if (!moo_glade_xml_fill_widget (xml->xml, root, _lua_page_xml_glade_xml, -1, "LuaPage", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _lua_page_xml_finish_build (xml);
}

static LuaPageXml *
lua_page_xml_new_empty (void)
{
    LuaPageXml *xml = g_new0 (LuaPageXml, 1);
    xml->xml = moo_glade_xml_new_empty (GETTEXT_PACKAGE);

    return xml;
}

G_GNUC_UNUSED static LuaPageXml *
lua_page_xml_new (void)
{
    LuaPageXml *xml = lua_page_xml_new_empty ();
    if (!lua_page_xml_build (xml))
    {
        _lua_page_xml_free (xml);
        xml = NULL;
    }
    return xml;
}

G_GNUC_UNUSED static LuaPageXml *
lua_page_xml_new_with_root (GtkWidget *root)
{
    LuaPageXml *xml = lua_page_xml_new_empty ();
    if (!lua_page_xml_fill (xml, root))
    {
        _lua_page_xml_free (xml);
        xml = NULL;
    }
    return xml;
}
