#include <mooutils/mooglade.h>
#include <mooutils/mooi18n.h>
#include <gtk/gtk.h>

static const char moousertools_glade_xml[] =
"<?xml version=\"1.0\"?>"
"<glade-interface>"
"  <requires-version lib=\"gtk+\" version=\"2.12\"/>"
"  <widget class=\"GtkWindow\" id=\"window1\">"
"    <property name=\"visible\">True</property>"
"    <property name=\"title\">window1</property>"
"    <child>"
"      <widget class=\"GtkVBox\" id=\"Command\">"
"        <property name=\"visible\">True</property>"
"        <property name=\"border_width\">12</property>"
"        <property name=\"spacing\">18</property>"
"        <child>"
"          <widget class=\"GtkHBox\" id=\"hbox1\">"
"            <property name=\"visible\">True</property>"
"            <property name=\"spacing\">6</property>"
"            <child>"
"              <widget class=\"GtkVBox\" id=\"vbox2\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"spacing\">6</property>"
"                <child>"
"                  <widget class=\"GtkScrolledWindow\" id=\"scrolledwindow1\">"
"                    <property name=\"visible\">True</property>"
"                    <property name=\"can_focus\">False</property>"
"                    <property name=\"hscrollbar_policy\">GTK_POLICY_AUTOMATIC</property>"
"                    <property name=\"vscrollbar_policy\">GTK_POLICY_AUTOMATIC</property>"
"                    <property name=\"shadow_type\">GTK_SHADOW_IN</property>"
"                    <child>"
"                      <widget class=\"GtkTreeView\" id=\"treeview\">"
"                        <property name=\"visible\">True</property>"
"                        <property name=\"border_width\">3</property>"
"                        <property name=\"headers_visible\">False</property>"
"                      </widget>"
"                    </child>"
"                  </widget>"
"                </child>"
"                <child>"
"                  <widget class=\"GtkHBox\" id=\"hbox2\">"
"                    <property name=\"visible\">True</property>"
"                    <property name=\"spacing\">6</property>"
"                    <child>"
"                      <widget class=\"GtkButton\" id=\"new\">"
"                        <property name=\"visible\">True</property>"
"                        <property name=\"tooltip\" translatable=\"yes\">New item</property>"
"                        <property name=\"focus_on_click\">False</property>"
"                        <property name=\"response_id\">0</property>"
"                        <child>"
"                          <widget class=\"GtkImage\" id=\"image3\">"
"                            <property name=\"visible\">True</property>"
"                            <property name=\"stock\">gtk-new</property>"
"                          </widget>"
"                        </child>"
"                      </widget>"
"                      <packing>"
"                        <property name=\"expand\">False</property>"
"                        <property name=\"fill\">False</property>"
"                      </packing>"
"                    </child>"
"                    <child>"
"                      <widget class=\"GtkButton\" id=\"delete\">"
"                        <property name=\"visible\">True</property>"
"                        <property name=\"tooltip\" translatable=\"yes\">Delete item</property>"
"                        <property name=\"focus_on_click\">False</property>"
"                        <property name=\"response_id\">0</property>"
"                        <child>"
"                          <widget class=\"GtkImage\" id=\"image4\">"
"                            <property name=\"visible\">True</property>"
"                            <property name=\"stock\">gtk-delete</property>"
"                          </widget>"
"                        </child>"
"                      </widget>"
"                      <packing>"
"                        <property name=\"expand\">False</property>"
"                        <property name=\"fill\">False</property>"
"                        <property name=\"position\">1</property>"
"                      </packing>"
"                    </child>"
"                    <child>"
"                      <widget class=\"GtkButton\" id=\"down\">"
"                        <property name=\"visible\">True</property>"
"                        <property name=\"tooltip\" translatable=\"yes\">Move item down</property>"
"                        <property name=\"focus_on_click\">False</property>"
"                        <property name=\"response_id\">0</property>"
"                        <child>"
"                          <widget class=\"GtkImage\" id=\"image2\">"
"                            <property name=\"visible\">True</property>"
"                            <property name=\"stock\">gtk-go-down</property>"
"                          </widget>"
"                        </child>"
"                      </widget>"
"                      <packing>"
"                        <property name=\"expand\">False</property>"
"                        <property name=\"fill\">False</property>"
"                        <property name=\"position\">2</property>"
"                      </packing>"
"                    </child>"
"                    <child>"
"                      <widget class=\"GtkButton\" id=\"up\">"
"                        <property name=\"visible\">True</property>"
"                        <property name=\"tooltip\" translatable=\"yes\">Move item up</property>"
"                        <property name=\"focus_on_click\">False</property>"
"                        <property name=\"response_id\">0</property>"
"                        <child>"
"                          <widget class=\"GtkImage\" id=\"image1\">"
"                            <property name=\"visible\">True</property>"
"                            <property name=\"stock\">gtk-go-up</property>"
"                          </widget>"
"                        </child>"
"                      </widget>"
"                      <packing>"
"                        <property name=\"expand\">False</property>"
"                        <property name=\"fill\">False</property>"
"                        <property name=\"position\">3</property>"
"                      </packing>"
"                    </child>"
"                  </widget>"
"                  <packing>"
"                    <property name=\"expand\">False</property>"
"                    <property name=\"fill\">False</property>"
"                    <property name=\"position\">1</property>"
"                  </packing>"
"                </child>"
"              </widget>"
"              <packing>"
"                <property name=\"expand\">False</property>"
"                <property name=\"fill\">False</property>"
"              </packing>"
"            </child>"
"            <child>"
"              <widget class=\"GtkVBox\" id=\"tool_vbox\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"spacing\">6</property>"
"                <child>"
"                  <widget class=\"GtkTable\" id=\"table\">"
"                    <property name=\"visible\">True</property>"
"                    <property name=\"n_rows\">4</property>"
"                    <property name=\"n_columns\">2</property>"
"                    <property name=\"column_spacing\">6</property>"
"                    <property name=\"row_spacing\">6</property>"
"                    <child>"
"                      <widget class=\"GtkHBox\" id=\"hbox3\">"
"                        <property name=\"visible\">True</property>"
"                        <child>"
"                          <widget class=\"GtkLabel\" id=\"label5\">"
"                            <property name=\"visible\">True</property>"
"                            <property name=\"label\" translatable=\"yes\">Command type:</property>"
"                          </widget>"
"                          <packing>"
"                            <property name=\"expand\">False</property>"
"                            <property name=\"fill\">False</property>"
"                            <property name=\"padding\">3</property>"
"                          </packing>"
"                        </child>"
"                        <child>"
"                          <widget class=\"GtkComboBox\" id=\"type_combo\">"
"                            <property name=\"visible\">True</property>"
"                            <property name=\"items\" translatable=\"yes\"></property>"
"                          </widget>"
"                          <packing>"
"                            <property name=\"expand\">False</property>"
"                            <property name=\"position\">1</property>"
"                          </packing>"
"                        </child>"
"                      </widget>"
"                      <packing>"
"                        <property name=\"right_attach\">2</property>"
"                        <property name=\"top_attach\">3</property>"
"                        <property name=\"bottom_attach\">4</property>"
"                        <property name=\"x_options\">GTK_FILL</property>"
"                        <property name=\"y_options\"></property>"
"                      </packing>"
"                    </child>"
"                    <child>"
"                      <widget class=\"GtkCheckButton\" id=\"enabled\">"
"                        <property name=\"visible\">True</property>"
"                        <property name=\"label\" translatable=\"yes\">Enabled</property>"
"                        <property name=\"use_underline\">True</property>"
"                        <property name=\"focus_on_click\">False</property>"
"                        <property name=\"response_id\">0</property>"
"                        <property name=\"draw_indicator\">True</property>"
"                      </widget>"
"                      <packing>"
"                        <property name=\"right_attach\">2</property>"
"                        <property name=\"y_options\"></property>"
"                      </packing>"
"                    </child>"
"                    <child>"
"                      <widget class=\"GtkLabel\" id=\"label8\">"
"                        <property name=\"visible\">True</property>"
"                        <property name=\"xalign\">1</property>"
"                        <property name=\"label\" translatable=\"yes\">Files:</property>"
"                      </widget>"
"                      <packing>"
"                        <property name=\"top_attach\">1</property>"
"                        <property name=\"bottom_attach\">2</property>"
"                        <property name=\"x_options\">GTK_FILL</property>"
"                        <property name=\"y_options\"></property>"
"                      </packing>"
"                    </child>"
"                    <child>"
"                      <widget class=\"GtkEntry\" id=\"filter\">"
"                        <property name=\"visible\">True</property>"
"                      </widget>"
"                      <packing>"
"                        <property name=\"left_attach\">1</property>"
"                        <property name=\"right_attach\">2</property>"
"                        <property name=\"top_attach\">1</property>"
"                        <property name=\"bottom_attach\">2</property>"
"                        <property name=\"y_options\"></property>"
"                      </packing>"
"                    </child>"
"                    <child>"
"                      <widget class=\"GtkLabel\" id=\"label9\">"
"                        <property name=\"visible\">True</property>"
"                        <property name=\"xalign\">1</property>"
"                        <property name=\"label\" translatable=\"yes\">Options:</property>"
"                      </widget>"
"                      <packing>"
"                        <property name=\"top_attach\">2</property>"
"                        <property name=\"bottom_attach\">3</property>"
"                        <property name=\"x_options\">GTK_FILL</property>"
"                        <property name=\"y_options\"></property>"
"                      </packing>"
"                    </child>"
"                    <child>"
"                      <widget class=\"GtkEntry\" id=\"options\">"
"                        <property name=\"visible\">True</property>"
"                      </widget>"
"                      <packing>"
"                        <property name=\"left_attach\">1</property>"
"                        <property name=\"right_attach\">2</property>"
"                        <property name=\"top_attach\">2</property>"
"                        <property name=\"bottom_attach\">3</property>"
"                        <property name=\"y_options\"></property>"
"                      </packing>"
"                    </child>"
"                  </widget>"
"                  <packing>"
"                    <property name=\"expand\">False</property>"
"                    <property name=\"fill\">False</property>"
"                  </packing>"
"                </child>"
"                <child>"
"                  <widget class=\"GtkAlignment\" id=\"alignment1\">"
"                    <property name=\"visible\">True</property>"
"                    <property name=\"top_padding\">3</property>"
"                    <property name=\"bottom_padding\">3</property>"
"                    <property name=\"left_padding\">3</property>"
"                    <property name=\"right_padding\">3</property>"
"                    <child>"
"                      <widget class=\"GtkNotebook\" id=\"type_notebook\">"
"                        <property name=\"visible\">True</property>"
"                        <property name=\"show_tabs\">False</property>"
"                        <property name=\"show_border\">False</property>"
"                      </widget>"
"                    </child>"
"                  </widget>"
"                  <packing>"
"                    <property name=\"position\">1</property>"
"                  </packing>"
"                </child>"
"              </widget>"
"              <packing>"
"                <property name=\"position\">1</property>"
"              </packing>"
"            </child>"
"          </widget>"
"        </child>"
"      </widget>"
"    </child>"
"  </widget>"
"  <widget class=\"GtkWindow\" id=\"window3\">"
"    <property name=\"visible\">True</property>"
"    <property name=\"title\">window3</property>"
"    <child>"
"      <widget class=\"GtkVBox\" id=\"PrefsPage\">"
"        <property name=\"visible\">True</property>"
"        <child>"
"          <widget class=\"GtkNotebook\" id=\"notebook\">"
"            <property name=\"visible\">True</property>"
"            <child>"
"              <widget class=\"GtkVBox\" id=\"page_menu:MooPrefsPage\">"
"                <property name=\"visible\">True</property>"
"                <child>"
"                  <placeholder/>"
"                </child>"
"              </widget>"
"            </child>"
"            <child>"
"              <widget class=\"GtkLabel\" id=\"label12\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"label\" translatable=\"yes\">Tools menu</property>"
"              </widget>"
"              <packing>"
"                <property name=\"tab_fill\">False</property>"
"                <property name=\"type\">tab</property>"
"              </packing>"
"            </child>"
"            <child>"
"              <widget class=\"GtkVBox\" id=\"page_context:MooPrefsPage\">"
"                <property name=\"visible\">True</property>"
"                <child>"
"                  <placeholder/>"
"                </child>"
"              </widget>"
"              <packing>"
"                <property name=\"position\">1</property>"
"              </packing>"
"            </child>"
"            <child>"
"              <widget class=\"GtkLabel\" id=\"label13\">"
"                <property name=\"visible\">True</property>"
"                <property name=\"label\" translatable=\"yes\">Context menu</property>"
"              </widget>"
"              <packing>"
"                <property name=\"position\">1</property>"
"                <property name=\"tab_fill\">False</property>"
"                <property name=\"type\">tab</property>"
"              </packing>"
"            </child>"
"          </widget>"
"        </child>"
"      </widget>"
"    </child>"
"  </widget>"
"</glade-interface>"

;

typedef struct CommandXml CommandXml;

struct CommandXml {
    MooGladeXML *xml;

    GtkVBox *Command;
    GtkTreeView *treeview;
    GtkButton *new_;
    GtkButton *delete_;
    GtkButton *down;
    GtkButton *up;
    GtkVBox *tool_vbox;
    GtkTable *table;
    GtkComboBox *type_combo;
    GtkCheckButton *enabled;
    GtkEntry *filter;
    GtkEntry *options;
    GtkNotebook *type_notebook;

};

static void
_command_xml_free (CommandXml *xml)
{
    if (xml)
    {
        if (xml->xml)
            g_object_unref (xml->xml);
        g_free (xml);
    }
}

G_GNUC_UNUSED static CommandXml *
command_xml_get (gpointer widget)
{
    return (CommandXml*) g_object_get_data (G_OBJECT (widget), "moo-generated-glade-xml");
}

static gboolean
_command_xml_finish_build (CommandXml *xml)
{
    g_return_val_if_fail(xml != NULL, FALSE);

    xml->Command = (GtkVBox*) moo_glade_xml_get_widget (xml->xml, "Command");
    g_return_val_if_fail (xml->Command != NULL, FALSE);
    xml->treeview = (GtkTreeView*) moo_glade_xml_get_widget (xml->xml, "treeview");
    g_return_val_if_fail (xml->treeview != NULL, FALSE);
    xml->new_ = (GtkButton*) moo_glade_xml_get_widget (xml->xml, "new");
    g_return_val_if_fail (xml->new_ != NULL, FALSE);
    xml->delete_ = (GtkButton*) moo_glade_xml_get_widget (xml->xml, "delete");
    g_return_val_if_fail (xml->delete_ != NULL, FALSE);
    xml->down = (GtkButton*) moo_glade_xml_get_widget (xml->xml, "down");
    g_return_val_if_fail (xml->down != NULL, FALSE);
    xml->up = (GtkButton*) moo_glade_xml_get_widget (xml->xml, "up");
    g_return_val_if_fail (xml->up != NULL, FALSE);
    xml->tool_vbox = (GtkVBox*) moo_glade_xml_get_widget (xml->xml, "tool_vbox");
    g_return_val_if_fail (xml->tool_vbox != NULL, FALSE);
    xml->table = (GtkTable*) moo_glade_xml_get_widget (xml->xml, "table");
    g_return_val_if_fail (xml->table != NULL, FALSE);
    xml->type_combo = (GtkComboBox*) moo_glade_xml_get_widget (xml->xml, "type_combo");
    g_return_val_if_fail (xml->type_combo != NULL, FALSE);
    xml->enabled = (GtkCheckButton*) moo_glade_xml_get_widget (xml->xml, "enabled");
    g_return_val_if_fail (xml->enabled != NULL, FALSE);
    xml->filter = (GtkEntry*) moo_glade_xml_get_widget (xml->xml, "filter");
    g_return_val_if_fail (xml->filter != NULL, FALSE);
    xml->options = (GtkEntry*) moo_glade_xml_get_widget (xml->xml, "options");
    g_return_val_if_fail (xml->options != NULL, FALSE);
    xml->type_notebook = (GtkNotebook*) moo_glade_xml_get_widget (xml->xml, "type_notebook");
    g_return_val_if_fail (xml->type_notebook != NULL, FALSE);

    g_object_set_data_full (G_OBJECT (xml->Command), "moo-generated-glade-xml",
                            xml, (GDestroyNotify) _command_xml_free);
    return TRUE;
}

static gboolean
command_xml_build (CommandXml *xml)
{
    GError *error = NULL;
    if (!moo_glade_xml_parse_memory (xml->xml, moousertools_glade_xml, -1, "Command", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _command_xml_finish_build (xml);
}

static gboolean
command_xml_fill (CommandXml *xml, GtkWidget *root)
{
    GError *error = NULL;
    if (!moo_glade_xml_fill_widget (xml->xml, root, moousertools_glade_xml, -1, "Command", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _command_xml_finish_build (xml);
}

static CommandXml *
command_xml_new_empty (void)
{
    CommandXml *xml = g_new0 (CommandXml, 1);
    xml->xml = moo_glade_xml_new_empty (GETTEXT_PACKAGE);

    return xml;
}

G_GNUC_UNUSED static CommandXml *
command_xml_new (void)
{
    CommandXml *xml = command_xml_new_empty ();
    if (!command_xml_build (xml))
    {
        _command_xml_free (xml);
        xml = NULL;
    }
    return xml;
}

G_GNUC_UNUSED static CommandXml *
command_xml_new_with_root (GtkWidget *root)
{
    CommandXml *xml = command_xml_new_empty ();
    if (!command_xml_fill (xml, root))
    {
        _command_xml_free (xml);
        xml = NULL;
    }
    return xml;
}
typedef struct PrefsPageXml PrefsPageXml;

struct PrefsPageXml {
    MooGladeXML *xml;

    GtkVBox *PrefsPage;
    GtkNotebook *notebook;
    MooPrefsPage *page_menu;
    MooPrefsPage *page_context;

};

static void
_prefs_page_xml_free (PrefsPageXml *xml)
{
    if (xml)
    {
        if (xml->xml)
            g_object_unref (xml->xml);
        g_free (xml);
    }
}

G_GNUC_UNUSED static PrefsPageXml *
prefs_page_xml_get (gpointer widget)
{
    return (PrefsPageXml*) g_object_get_data (G_OBJECT (widget), "moo-generated-glade-xml");
}

static gboolean
_prefs_page_xml_finish_build (PrefsPageXml *xml)
{
    g_return_val_if_fail(xml != NULL, FALSE);

    xml->PrefsPage = (GtkVBox*) moo_glade_xml_get_widget (xml->xml, "PrefsPage");
    g_return_val_if_fail (xml->PrefsPage != NULL, FALSE);
    xml->notebook = (GtkNotebook*) moo_glade_xml_get_widget (xml->xml, "notebook");
    g_return_val_if_fail (xml->notebook != NULL, FALSE);
    xml->page_menu = (MooPrefsPage*) moo_glade_xml_get_widget (xml->xml, "page_menu:MooPrefsPage");
    g_return_val_if_fail (xml->page_menu != NULL, FALSE);
    xml->page_context = (MooPrefsPage*) moo_glade_xml_get_widget (xml->xml, "page_context:MooPrefsPage");
    g_return_val_if_fail (xml->page_context != NULL, FALSE);

    g_object_set_data_full (G_OBJECT (xml->PrefsPage), "moo-generated-glade-xml",
                            xml, (GDestroyNotify) _prefs_page_xml_free);
    return TRUE;
}

static gboolean
prefs_page_xml_build (PrefsPageXml *xml)
{
    GError *error = NULL;
    if (!moo_glade_xml_parse_memory (xml->xml, moousertools_glade_xml, -1, "PrefsPage", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _prefs_page_xml_finish_build (xml);
}

static gboolean
prefs_page_xml_fill (PrefsPageXml *xml, GtkWidget *root)
{
    GError *error = NULL;
    if (!moo_glade_xml_fill_widget (xml->xml, root, moousertools_glade_xml, -1, "PrefsPage", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _prefs_page_xml_finish_build (xml);
}

static PrefsPageXml *
prefs_page_xml_new_empty (void)
{
    PrefsPageXml *xml = g_new0 (PrefsPageXml, 1);
    xml->xml = moo_glade_xml_new_empty (GETTEXT_PACKAGE);

    return xml;
}

G_GNUC_UNUSED static PrefsPageXml *
prefs_page_xml_new (void)
{
    PrefsPageXml *xml = prefs_page_xml_new_empty ();
    if (!prefs_page_xml_build (xml))
    {
        _prefs_page_xml_free (xml);
        xml = NULL;
    }
    return xml;
}

G_GNUC_UNUSED static PrefsPageXml *
prefs_page_xml_new_with_root (GtkWidget *root)
{
    PrefsPageXml *xml = prefs_page_xml_new_empty ();
    if (!prefs_page_xml_fill (xml, root))
    {
        _prefs_page_xml_free (xml);
        xml = NULL;
    }
    return xml;
}
